000100060707     H COPYRIGHT('Copyright (c) 2006-2006 Christian Vitroler.  All rights-
000200060624     H reserved.  See the FTPAPIR4 source member or printed documentation-
000300060624     H for full license and copyright details.')
000400060624
000500060624      *-                                                                            +
000600060707      * Copyright (c) 2006-2006 Christian Vitroler                                  +
000700060624      * All rights reserved.                                                        +
000800060624      *                                                                             +
000900060624      * Redistribution and use in source and binary forms, with or without          +
001000060624      * modification, are permitted provided that the following conditions          +
001100060624      * are met:                                                                    +
001200060624      * 1. Redistributions of source code must retain the above copyright           +
001300060624      *    notice, this list of conditions and the following disclaimer.            +
001400060624      * 2. Redistributions in binary form must reproduce the above copyright        +
001500060624      *    notice, this list of conditions and the following disclaimer in the      +
001600060624      *    documentation and/or other materials provided with the distribution.     +
001700060624      *                                                                             +
001800060624      * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ''AS IS'' AND      +
001900060624      * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE       +
002000060624      * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE  +
002100060624      * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE     +
002200060624      * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL  +
002300060624      * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS     +
002400060624      * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)       +
002500060624      * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT  +
002600060624      * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY   +
002700060624      * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF      +
002800060624      * SUCH DAMAGE.                                                                +
002900060624      */
003000060623
003100060623     H NOMAIN
003200060707     H Option(*SrcStmt)
003201060627     H BndDir('QC2LE')
003202060626
003300060704      * TODO:
003400060705      *  - FTP_Conn
003401060705      *  - FTP_Get
003402060705      *  - FTP_Put
003403060707      *  x XferDataAscii
003405060707      *  x XferDataBinary
003406060704      *  - OpenFileRead
003408060704      *  - OpenFileWrite
003409060705      *  x FTP_CodePage
003410060705      *  - ConnectPORT
003411060705      *  - FTP_PassiveMode
003412060705      *  x FTP_BinaryMode
003413060704      *  - lots of others
003600060704
004700060624      * TODO (cleanup)
004800060627      *  o rename IFS & socket APis (OpenF, CloseS, ReadF, etc.)
004900060624      *  - move FD_xxx & Exxxx consts to seperate module
005000060626      *  - move low level TCP (TCP_Connect, TCP_Send) to module
005100060624
005700060623
005800060623      *#########################################################################
005900060623      *  definitions
006000060623      *#########################################################################
006100060623
006200060623      * exported constants, data & procedures this service program -------------
006300060626      /include QRPGLESRC,FTPAPI_H
006400060623
006500060623      * imported constants, datatypes & prototypes
006600060626      /include QRPGLESRC,IFSIO_H
006700060626      /include QRPGLESRC,SOCKET_H
006800060623
006900060623
007000060623      * constants --------------------------------------------------------------
007100060623     D True            C                   *ON
007200060623     D False           C                   *OFF
007300060623
007400060630
007401060630     D UPPER           C                   'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
007402060630     D LOWER           C                   'abcdefghijklmnopqrstuvwxyz'
007403060630     D cMaxUnsigned    C                   4294967295
007500060623
007600060626     D DFT_TIMEOUT     C                   30
007700060629     D CRLF            C                   x'0D0A'
007701060629
007702060704      * constants for PathType in the TQlgPathName structure; QSYSINC/H/QLG
007703060704     D QLG_CHAR_SINGLE...
007704060704     D                 C                   0
007705060704     D QLG_PTR_SINGLE  C                   1
007706060704     D QLG_CHAR_DOUBLE...
007707060704     D                 C                   2
007708060704     D QLG_PTR_DOUBLE  C                   3
007709060704
007710060704      * constants used by Qp0lGetAttr() and Qp0lSetAttr(); QSYSINC/H/QP0LSTDI
007711060704      * indicator for following a symlink
007712060704     D QP0L_DONOT_FOLLOW_SYMLNK...
007713060704     D                 C                   0
007714060704     D QP0L_FOLLOW_SYMLNK...
007715060704     D                 C                   1
007716060704
007717060704      * attribute IDs
007718060704     D QP0L_ATTR_CCSID...
007719060704     D                 C                   27
007720060704
007800060623      *  Operation would have caused the process to block
007900060623     D EAGAIN          C                   3406
008000060623      *  A connection has already been establish
008100060623     D EISCONN         C                   3431
008200060623      *  Operation in progress.
008300060626     D EINPROGRESS     C                   3430
008400060623      * invalid argument (also used for "connection refused")
008500060623     D EINVAL          C                   3021
008501060626
008502060626     D EWOULDBLOCK     C                   3406
008503060626     D EPIPE           C                   3455
008504060705     D E2BIG           C                   3491
008505060705
008601060626     D teUnknown       C                   -1
008602060626     D teHostName      C                   -2
008603060626     D teCreateSocket  C                   -3
008604060629     D teTimeOut       C                   -4
008606060629     D teDisconnect    C                   -5
008609060629
008610060629     D cErrConvCtrlToRmt...
008611060629     D                 C                   'error during conversion of control -
008612060629     D                                     channel to server'
008613060629     D cErrConvCtrlToLcl...
008614060629     D                 C                   'error during conversion of control -
008615060629     D                                     channel from server'
008616060705     D cErrConvData    C                   'error during conversion of data -
008617060705     D                                     channel'
008619060705     D cErrConnCtrl    C                   'error connecting to control channel'
008620060629     D cErrSendCtrl    C                   'error sending on control channel'
008621060629     D cErrRecvCtrl    C                   'error receiving on control channel'
008622060704     D cErrDiscCtrl    C                   'disconnected on control channel'
008623060704     D cErrConnData    C                   'error connecting to data channel'
008624060703     D cErrSendData    C                   'error sending on data channel'
008625060703     D cErrRecvData    C                   'error receiving on data channel'
008626060703     D cErrSession     C                   'could not create a session handle'
008627060629     D cErrBadReplyConn...
008628060629     D                 C                   'server sent a bad reply on connect'
008629060629     D cErrBadHandle   C                   'session handle is invalid'
008630060707     D cErrReplyMalformed...
008631060707     D                 C                   'server did not send a proper reply -
008632060707     D                                     message'
008633060630     D cErrMDTMCannot  C                   'MDTM command not supported on -
008634060630     D                                     this server'
008635060707     D cErrParseMDTM   C                   'could not parse result of MDTM -
008636060707     D                                     command'
008637060703     D cErrPASVStr     C                   'unable to parse the PASV reply'
008638060629
008639060705
008700060626      * datatypes --------------------------------------------------------------
008900060623     D PDataType       S               *
009000060623
009001060626      * describes CCSID plus options used for conversion from/to
009002060626     D TQtqCode        DS                  Qualified Based(PDataType)
009003060626     D   CCSID                       10I 0
009004060626     D   CnvAlter                    10I 0
009005060626     D   SubstAlter                  10I 0
009006060626     D   ShiftAlter                  10I 0
009007060626     D   LengthOption                10I 0
009008060626     D   MixedErrOpt                 10I 0
009009060626     D   Reserved                     8
009010060626
009011060626      * conversion descriptor used by conversion APIs
009012060626     D TIconv          DS                  Qualified Based(PDataType)
009013060626     D   return_value                10I 0
009014060629     D   CD                          10I 0 Dim(12)
009015060626
009016060704      * NLS enabled path name structure
009017060704     D TQlgPathName    DS                  Qualified Based(PDataType)
009018060704     D   CCSID                       10I 0
009019060704     D   CountryID                    2
009020060704     D   LangID                       3
009021060704     D   Reserved1                    3
009022060704     D   PathType                    10U 0
009023060704     D   PathLen                     10I 0
009024060704     D   PathDelim                    2
009025060704     D   Reserved2                   10
009026060704     D   PathName                   256
009027060704     D   PathPtr                       *   Overlay(PathName)
009028060704
009029060704      * Qp0lGetAttr() and Qp0lSetAttr() attribute data header
009030060704     D TQp0lAttrHdr    DS                  Qualified Based(PDataType)
009031060704     D   NextAttrOffs                10U 0
009032060704     D   AttrID                      10U 0
009033060704     D   AttrSize                    10U 0
009034060704     D   Reserved                     4
009035060704
009036060626     D TErrorStr       S             80A   varying based(PDatatype)
009037060629     D TReplyStr       S            256A   varying based(PDatatype)
009038060704     D TFilePath       S            256A   varying Based(PDataType)
009039060704
009100060623     D TSessionRec     DS                  qualified based(PDatatype)
009101060627     D   Handle                      10I 0
009200060623     D   Socket                      10I 0
009201060626     D   Timeout                     10I 0
009202060703     D   DataSocket                  10I 0
009203060704     D   CtrlBuff                  4096A
009310060627     D   CtrlBLen                    10I 0
009311060703     D   DataBuff                 32766A
009312060703     D   DataBLen                    10I 0
009313060704     D   DataCRLF                     4A   varying
009314060704     D   ClosePtr                      *   procptr
009315060704     D   FileDescr                   10I 0
009316060704     D   EmptyLine                     N
009317060704     D   UsePASV                       N
009318060704     D   Binary                        N
009319060703     D   CanUTF8                       N
009320060630     D   CanSSL                        N
009321060630     D   CanTLS                        N
009322060630     D   CanMDTM                       N
009323060630     D   CanSIZE                       N
009324060703     D   DirArrPtr                     *
009325060703     D   DirMaxCnt                   10U 0
009326060703     D   DirRmtCnt                   10U 0
009327060704     D   LclCCSID                    10I 0
009328060704     D   RmtCCSID                    10I 0
009329060704     D   Error                       10I 0
009330060626     D   ErrorStr                          like(TErrorStr)
009331060704      /if defined(*V5R2M0)
009332060704     D   CDRmtCtrl                         likeds(TIconv)
009333060704     D   CDLclCtrl                         likeds(TIconv)
009334060704     D   CDRmtData                         likeds(TIconv)
009335060704     D   CDLclData                         likeds(TIconv)
009336060704      /else
009337060704     D   CDRmtCtrl                         like(TIconv)
009338060704     D   CDLclCtrl                         like(TIconv)
009339060704     D   CDRmtData                         like(TIconv)
009340060704     D   CDLclData                         like(TIconv)
009341060704      /endif
009342060704
009343060626
009401060626      * external prototypes ----------------------------------------------------
009402060626     D StrError        PR              *   extproc('strerror')
009403060626     D   iErrno                      10I 0 value
009404060626
009405060626     D atoi            PR            10I 0 extproc('atoi')
009406060626     D   iString                       *   value options(*string)
009407060626
009408060705      *  move iCount bytes from memory address to memory address (ILE C/C++)
009409060705     D MemMove         PR                  extproc('memmove')
009410060705     D   iBuffDst                      *   value
009411060705     D   iBuffSrc                      *   value
009412060705     D   iCount                      10U 0 value
009413060705
009414060626      * http://publib.boulder.ibm.com/infocenter/iseries/v5r4/topic/apis/nls3.htm
009415060626     D QtqIconvOpen    PR                  LikeDS(TIconv)
009416060626     D                                     ExtProc('QtqIconvOpen')
009417060626     D   iToCode                           Const LikeDS(TQtqCode)
009418060626     D   iFromCode                         Const LikeDS(TQtqCode)
009419060626
009420060626     D iconv_close     PR            10I 0 ExtProc('iconv_close')
009421060629     D   iCD                               Value LikeDS(TIconv)
009422060626
009423060626     D Iconv           PR            10U 0 ExtProc('iconv')
009424060629     D   iCD                               Value LikeDS(TIconv)
009425060626     D   iPtrInpBuff                   *   Const
009426060626     D   InpBytesLeft                10U 0
009427060626     D   iPtrOutBuff                   *   Const
009428060626     D   OutBytesLeft                10U 0
009429060626
009430060704     D Qp0lSetAttr     PR            10I 0 ExtProc('Qp0lSetAttr')
009431060704     D   iQlgPathName                      Like(TQlgPathName)
009432060704     D   iBuffer                     26    Options(*VarSize)
009433060704     D   iBufferSize                 10U 0 Value
009434060704     D   iFlwSymLnk                  10U 0 Value
009435060704
009436060627      * http://publib.boulder.ibm.com/infocenter/iseries/v5r4/topic/apis/mh1.htm
009437060627      * send program message
009438060627     D QMHSNDPM        PR                  ExtPgm('QMHSNDPM')
009439060627     D   iMsgID                       7    Const
009440060627     D   iQualMsgFile                20    Const
009441060627     D   iMsgDataText             32767    Const Options(*VarSize)
009442060627     D   iMsgDataLen                 10I 0 Const
009443060627     D   iMsgType                    10    Const
009444060627     D   iCallStkEnt                 10    Const Options(*VarSize)
009445060627     D   iCallStkCnt                 10I 0 Const
009446060627     D   oMsgKey                      4
009447060627     D   aError                   32767    Options(*VarSize)
009448060627      * first optional group
009449060627     D   iCallStkLen                 10I 0 Const Options(*NoPass)
009450060627     D   iCallStkQual                20    Const Options(*NoPass)
009451060627     D   iDspMsgWait                 10I 0 Const Options(*NoPass)
009452060627      * second optional group
009453060627     D   iCallStkType                10    Const Options(*NoPass)
009454060627     D   iDataCCSID                  10I 0 Const Options(*NoPass)
009455060627
009456060704      * local prototypes -------------------------------------------------------
009600060623     D CreateSession   PR            10I 0
009700060623
009800060623     D GetSessionPtr   PR              *
009900060627     D   iHandle                     10I 0 value
010000060623
010001060626     D GetActSession   PR              *
010002060627     D   iHandle                     10I 0 value
010003060626
010100060623     D ReleaseSession  PR
010200060627     D   iHandle                     10I 0 value
010300060623
010301060629     D ChgCtrlCCSID    PR
010302060629     D   aSession                          likeds(TSessionRec)
010303060629     D   iLclCCSID                   10I 0 value
010304060629     D   iRmtCCSID                   10I 0 value
010305060704
010306060704     D ChgDataCCSID    PR
010307060704     D   aSession                          likeds(TSessionRec)
010308060704     D   iLclCCSID                   10I 0 value
010309060704     D   iRmtCCSID                   10I 0 value
010310060704
010328060626     D SendLine        PR            10I 0
010329060626     D   aSession                          likeds(TSessionRec)
010330060626     D   iLine                     1024A   value
010331060626
010332060626     D Reply           PR            10I 0
010333060626     D   aSession                          likeds(TSessionRec)
010334060629     D   oResponse                         like(TReplyStr) options(*nopass)
010335060626
010336060626     D RecvLine        PR            10I 0
010337060626     D   aSession                          likeds(TSessionRec)
010338060626     D   oLine                     1024A
010339060626
010340060630     D GetFeatures     PR            10I 0
010341060630     D   aSession                          likeds(TSessionRec)
010342060630
010343060630     D SetUTF8         PR            10I 0
010344060630     D   aSession                          likeds(TSessionRec)
010345060630
010346060703     D ConnectPASV     PR            10I 0
010347060703     D   aSession                          likeds(TSessionRec)
010348060703
010349060705     D XferDataChunk   PR            10I 0
010350060703     D   aSession                          likeds(TSessionRec)
010351060703     D   iRecvProc                     *   value procptr
010354060703     D   iRecvDescr                  10I 0
010355060703     D   iSendProc                     *   value procptr
010356060703     D   iSendDescr                  10I 0
010357060703     D   iCD                               const likeds(TIconv)
010358060703
010359060705     D XferDataAscii   PR            10I 0
010360060703     D   aSession                          likeds(TSessionRec)
010361060703     D   iRecvProc                     *   value procptr
010362060703     D   iRecvDescr                  10I 0
010363060703     D   iSendProc                     *   value procptr
010364060703     D   iSendDescr                  10I 0
010365060703     D   iCD                               const likeds(TIconv)
010366060703
010367060705     D XferDataBinary  PR            10I 0
010368060705     D   aSession                          likeds(TSessionRec)
010369060705     D   iRecvProc                     *   value procptr
010370060705     D   iRecvDescr                  10I 0
010371060705     D   iSendProc                     *   value procptr
010372060705     D   iSendDescr                  10I 0
010373060705
010374060703     D RecvDataLine    PR            10I 0
010375060703     D   iHandle                     10I 0 value
010376060704     D   oBuffer                  32766A   options(*varsize)
010377060703     D   iBufLen                     10I 0 value
010378060703
010379060703     D RecvDataBlck    PR            10I 0
010380060703     D   iHandle                     10I 0 value
010381060703     D   iBuffer                  32766A   options(*varsize)
010382060703     D   iBufLen                     10I 0 value
010383060703
010384060703     D RecvDataStrm    PR            10I 0
010385060703     D   iHandle                     10I 0 value
010386060703     D   iBuffer                  32766A   options(*varsize)
010387060703     D   iBufLen                     10I 0 value
010388060704
010389060705     D SendDataStrm    PR            10I 0
010390060705     D   iHandle                     10I 0 value
010391060705     D   oBuffer                  32766A   options(*varsize)
010392060705     D   iBufLen                     10I 0 value
010393060705
010394060704     D CloseData       PR            10I 0
010395060704     D   aSession                          likeds(TSessionRec)
010396060704
010397060704     D OpenFileRead    PR            10I 0
010398060704     D   aSession                          likeds(TSessionRec)
010399060704     D   iLclPath                   256A   const
010400060704
010401060704     D OpenFileWrite   PR            10I 0
010402060704     D   aSession                          likeds(TSessionRec)
010403060704     D   iLclPath                   256A   const
010404060704
010405060704     D IF_Read         PR            10I 0
010406060704     D   iFileDes                    10I 0 value
010407060704     D   oBuffer                  32766A   options(*varsize)
010408060704     D   iBufLen                     10I 0 value
010409060704
010410060704     D IF_Write        PR            10I 0
010411060704     D   iFileDes                    10I 0 value
010412060704     D   iBuffer                  32766A   options(*varsize)
010413060704     D   iBufLen                     10I 0 value
010414060704
010415060704     D IF_Close        PR            10I 0
010416060704     D   iFileDes                    10I 0 value
010417060704
010418060704     D List2Array      PR            10I 0
010419060704     D   peHandle                    10I 0 value
010420060704     D   peBuffer                 32766A   options(*varsize)
010421060704     D   peBufLen                    10I 0 value
010422060704
010423060704     D AnalyzeResult   PR            10I 0
010424060626     D   aSession                          likeds(TSessionRec)
010425060626     D   iResult                     10I 0 value
010426060626     D   iErrorStr                         const like(TErrorStr)
010427060629     D   iDftError                   10I 0 value
010428060629     D   iDftErrorStr                      const like(TErrorStr)
010429060629
010430060629     D SetError        PR
010431060629     D   aSession                          likeds(TSessionRec)
010432060629     D   iError                      10I 0 value
010433060629     D   iErrorStr                         const like(TErrorStr)
010434060629
010435060629     D CreateCD        PR
010436060629     D   aCD                               likeds(TIconv)
010437060627     D   iSrcCCSID                   10I 0 value
010438060627     D   iDstCCSID                   10I 0 value
010439060627
010440060629     D FreeCD          PR
010441060629     D   aCD                               likeds(TIconv)
010442060627
010443060627     D SndDiagMsg      PR
010444060627     D   iMsgTxt                    256A   const
010445060627     D   iHandle                     10I 0 value
010446060627
010447060627     D SndInfoMsg      PR
010448060627     D   iMsgTxt                    256A   const
010449060627     D   iHandle                     10I 0 value
010450060627
010451060627     D SndMessage      PR
010452060627     D   iMsgType                    10A   const
010453060627     D   iCallStkEnt                 10    const
010454060627     D   iCallStkCnt                 10I 0 const
010455060627     D   iMsgTxt                    256A   const
010456060627     D   iHandle                     10I 0 value
010457060627
010458060627
010459060627     D TCP_Connect     PR            10I 0
010460060629     D   iHost                      256A   const
010461060629     D   iPort                        5U 0 value
010462060629     D   iTimeout                    10I 0 value
010463060629     D   oErrorStr                         like(TErrorStr) options(*nopass)
010464060627
010465060627     D TCP_Send        PR            10I 0
010466060627     D   iSocket                     10I 0 value
010467060629     D   iBufferPtr                    *   value
010468060629     D   iBufferLen                  10I 0 value
010469060627     D   iTimeout                    10I 0 value
010470060627     D   oErrorStr                         like(TErrorStr) options(*nopass)
010471060627
010472060627     D TCP_Recv        PR            10I 0
010473060627     D   iSocket                     10I 0 value
010474060629     D   iBufferPtr                    *   value
010475060629     D   iBufferLen                  10I 0 value
010476060627     D   iTimeout                    10I 0 value
010477060627     D   oErrorStr                         like(TErrorStr) options(*nopass)
010478060627
010479060629     D SetParmErrStr   PR
010480060629     D   iMaxParms                   10I 0 value
010481060629     D   iErrStrParm                 10I 0 value
010482060629     D   iErrorStr                         const like(TErrorStr)
010483060629     D   oErrorStr                         like(TErrorStr)
010484060629
010485060626     D ResolveIP       PR            10I 0
010486060629     D   iHost                      256A   const
010487060629     D   oIP                         10U 0
010488060629
014600060624      * replacements for C macros to be used with select()
014700060626     D FD_ZERO         PR
014900060624     D   aFD_Set                     28A
015000060624
015100060624     D FD_SET          PR
015200060624     D   iFD                         10I 0 value
015300060624     D   aFD_Set                     28A
015400060624
015500060624     D FD_CLR          PR
015600060624     D   iFD                         10I 0 value
015700060624     D   aFD_Set                     28A
015800060624
015900060624     D FD_ISSET        PR              N
016000060624     D   iFD                         10I 0 value
016100060628     D   iFD_Set                     28A
016200060624
016201060628      * error code for most C functions
018401060626     D ErrNo           PR            10I 0
018402060626
018403060704     D SetFileCCSID    PR            10I 0
018404060704     D   iFilePath                         Value Like(TFilePath)
018405060704     D   iFileCCSID                  10I 0 Const
018406060704
018407060704     D InitQlgPathPtr  PR
018408060704     D   aQlgPathName                      LikeDS(TQlgPathName)
018409060704     D   iPathPtr                      *   Value
018410060704     D   iPathSize                   10I 0 Value
018411060704
018500060623
018600060623      * global variables -------------------------------------------------------
018700060623     D SessionPtr      S               *
018800060623     D SessionCnt      S             10I 0
018900060623
019000060623
019100060623      *#########################################################################
019200060623      *  exported procedures (the API proper)
019300060623      *#########################################################################
019400060623
019500060623      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
019600060703      *  FTP_Conn:  connect *and* log-in to a FTP server
019700060623      *
019800060623      *     peHost = host name of FTP server to connect to
019900060623      *     peUser = user name on FTP server (or "anonymous")
020000060623      *     pePass = password for user name supplied (or "email@user.com")
020100060623      *     pePort = (optional) port to connect to; if not supplied,
020200060623      *              the value of the constant FTP_PORT will be used
020300060623      *  peTimeout = (optional) number of seconds to wait for data before
020400060623      *              assuming the connection is dead and giving up;
020500060623      *              if not given or set to 0, we wait indefinitely
020600060623      *     peAcct = (optional) account name (if required by server)
020700060623      *              if not given, a blank account name will be tried
020800060623      *              if the server requests an account name
020900060623      *
021000060703      *  returns the session handle of the connection upon success
021100060703      *          or -1 upon error
021200060623      *++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
021300060623     P FTP_Conn        B                   export
021400060623     D FTP_Conn        PI            10I 0
021500060623     D   peHost                     256A   const
021600060623     D   peUser                      32A   const
021700060623     D   pePass                      64A   const
021800060623     D   pePort                      10I 0 value options(*nopass)
021900060623     D   peTimeout                   10I 0 value options(*nopass)
022000060623     D   peAcct                      32A   const options(*nopass)
022100060623      *-------------------------------------------------------------------------
022200060623      /free
022300060623
022301060629
022400060624       return -1;
022500060623
022600060623      /end-free
022700060623     P                 E
022800060623
022900060623
023000060623      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
023100060623      *  FTP_Open: open a connection to a FTP server
023200060623      *
023300060623      *     peHost = host name of FTP server to connect to
023400060623      *     pePort = (optional) port to connect to; if not supplied,
023500060623      *              the value of the constant FTP_PORT will be used
023600060623      *  peTimeout = (optional) number of seconds to wait for data before
023700060623      *              assuming the connection is dead and giving up;
023800060623      *              if not given or set to 0, we wait indefinitely
023900060623      *
024000060703      *  returns the session handle of the connection upon success
024100060703      *          or -1 upon error
024200060623      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
024300060623     P FTP_Open        B                   export
024400060623     D FTP_Open        PI            10I 0
024500060623     D   peHost                     256A   const
024600060623     D   pePort                      10I 0 value options(*nopass)
024700060623     D   peTimeout                   10I 0 value options(*nopass)
024800060623
024900060629     D wSessPtr        S               *
025000060629     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
025100060623
025200060623     D wSocket         S             10I 0
025300060623     D wPort           S              5U 0 inz(FTP_PORT)
025400060627     D wTimeout        S             10I 0 inz(DFT_TIMEOUT)
025500060627     D wHandle         S             10I 0 inz(-1)
025600060629     D wErrorStr       S                   like(TErrorStr)
025601060629     D wReply          S             10I 0
025602060629      *-------------------------------------------------------------------------
025700060623      /free
025800060623
025900060623       if (%parms >= 2) and (pePort > 0);
026000060623         wPort = pePort;
026100060623       endif;
026200060623
026300060623       if (%parms >= 3) and (peTimeout > 0);
026400060623         wTimeout = peTimeout;
026500060623       endif;
026600060623
026601060629       // connect to remote server
026700060629       wSocket = TCP_Connect(peHost: wPort: wTimeout: wErrorStr);
026701060703       select;
026800060703       when (wSocket < 0);
026900060703         return AnalyzeResult(wSession: wSocket: wErrorStr: FTP_ERRCON:
026901060703            cErrConnCtrl);
026902060703       other;
026903060703         wHandle = CreateSession;
026904060627         if (wHandle >= 0);
026905060629           wSessPtr = GetSessionPtr(wHandle);
027100060629           wSession.Socket = wSocket;
027101060629           wSession.Timeout = wTimeout;
027102060626         else;
027103060626           callp close(wSocket);
027104060703           return AnalyzeResult(wSession: wHandle: cErrSession: FTP_ERRCON:
027106060629              cErrConnCtrl);
027107060629         endif;
027200060703       endsl;
027300060623
027301060629       // get connection response from server
027302060629       wReply = Reply(wSession);
027304060629       if (wReply <> 220);
027305060629         // either we are not connected or we got an unexpected reply
027306060629         if (wReply > 0);
027307060629           SetError(wSession: FTP_BADRES: cErrBadReplyConn);
027308060629         endif;
027309060629         callp close(wSocket);
027403060627         ReleaseSession(wHandle);
027404060629         return -1;
027405060629       endif;
027407060627
027417060630       // we are obviously connected, now get the feature list
027418060630       wReply = GetFeatures(wSession);
027419060630       if (wReply < 0);
027420060630         return -1;
027421060630       endif;
027422060630
027423060630       // shiny!
027424060629       return wHandle;
027501060627
027600060623      /end-free
027700060623     P                 E
027800060623
027900060623
028000060623      *++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
028100060703      *  FTP_Login: log-in to an already connected FTP server
028200060623      *
028300060623      *   peHandle = session handle returned by FTP_Open()
028400060623      *     peUser = user name on FTP server (or "anonymous")
028500060623      *     pePass = password for user name supplied (or "email@user.com")
028600060623      *     peAcct = (optional) account name (if required by server)
028700060623      *              if not given, a blank account name will be tried
028800060623      *              if the server requests an account name
028900060623      *
029000060623      *  returns 0 upon success or -1 upon error
029100060623      *++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
029200060623     P FTP_Login       B                   export
029300060623     D FTP_Login       PI            10I 0
029400060623     D   peHandle                    10I 0 value
029500060623     D   peUser                      32A   const
029600060623     D   pePass                      64A   const options(*nopass)
029700060623     D   peAcct                      32A   const options(*nopass)
029800060629
029801060629     D wSessPtr        S               *
029802060629     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
029803060629
029804060629     D wPass           S                   like(pePass)
029805060629     D wAcct           S                   like(peAcct)
029806060629
029807060629     D wReply          S             10I 0
029808060629     D wReplyStr       S                   like(TReplyStr)
029809060629      *-------------------------------------------------------------------------
029900060623      /free
030000060623
030001060629       wSessPtr = GetActSession(peHandle);
030002060629       if (wSessPtr = *NULL);
030003060629         SetError(wSession: FTP_BADHDL: cErrBadHandle);
030004060629         return -1;
030005060629       endif;
030006060629
030007060629       // set up optional parameters
030008060629       if (%parms >= 3);
030009060629         wPass = pePass;
030010060629       endif;
030011060629
030013060629       if (%parms >= 4);
030014060629         wAcct = peAcct;
030015060629       endif;
030016060629
030017060629       // send user name
030018060705       if (SendLine(wSession: 'USER ' + peUser) < 0);
030019060629         return -1;
030020060629       endif;
030021060629
030022060629       wReply = Reply(wSession: wReplyStr);
030023060629       select;
030024060629       when (wReply = 230);
030025060630         return SetUTF8(wSession);
030026060629       when (wReply = 331) and (wPass <> *BLANKS);
030027060629       when (wReply < 0);
030028060629         return -1;
030029060629       other;
030030060629         SetError(wSession: FTP_BADUSR: wReplyStr);
030031060629         return -1;
030032060629       endsl;
030033060629
030034060629       // send password, as it seems to be required
030035060705       if (SendLine(wSession: 'PASS ' + wPass) < 0);
030036060629         return -1;
030037060629       endif;
030038060629
030039060629       wReply = Reply(wSession: wReplyStr);
030040060629       select;
030041060629       when (wReply = 230);
030042060630         return SetUTF8(wSession);
030043060629       when (wReply = 332) and (wAcct <> *BLANKS);
030044060629       when (wReply < 0);
030045060629         return -1;
030046060629       other;
030047060629         SetError(wSession: FTP_BADPAS: wReplyStr);
030048060629         return -1;
030049060629       endsl;
030050060629
030051060629       // send account, as it seems to be required
030052060705       if (SendLine(wSession: 'ACCT ' + wAcct) < 0);
030053060629         return -1;
030054060629       endif;
030055060629
030056060629       wReply = Reply(wSession: wReplyStr);
030057060629       select;
030058060629       when (wReply = 230);
030059060630         return SetUTF8(wSession);
030060060629       when (wReply < 0);
030061060629         return -1;
030062060629       other;
030063060629         SetError(wSession: FTP_BADACT: wReplyStr);
030064060629         return -1;
030065060629       endsl;
030066060629
030300060623      /end-free
030400060623     P                 E
030500060623
030600060623
030700060623      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
030800060703      *  FTP_Quit: quit connection to FTP server and release session
030900060623      *
031000060623      *   peHandle = session handle returned by FTP_Conn() or FTP_Open()
031100060623      *
031200060623      *  this procedure logs off of the FTP server and closes the network
031300060623      *  connection; relases internal data
031400060623      *
031500060623      *  returns 0 upon success or -1 upon error
031600060623      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
031700060623     P FTP_Quit        B                   export
031800060623     D FTP_Quit        PI            10I 0
031900060623     D   peHandle                    10I 0 value
032000060623
032100060629     D wSessPtr        S               *
032200060629     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
032300060623      *-------------------------------------------------------------------------
032400060623      /free
032500060623
032600060629       wSessPtr = GetActSession(peHandle);
032700060629       if (wSessPtr = *NULL);
032701060629         SetError(wSession: FTP_BADHDL: cErrBadHandle);
032702060629         return -1;
032900060623       endif;
033000060623
033001060629       if (SendLine(wSession: 'QUIT') = 0);
033002060629         // be a good boy and read the good-bye message
033003060629         Reply(wSession);
033300060623       endif;
033301060626
033302060629       callp Close(wSession.Socket);
033500060626       ReleaseSession(peHandle);
033501060626
033700060623       return 0;
033800060623
033900060623      /end-free
034000060623     P                 E
034100060623
034101060703
034102060703      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034103060703      *  FTP_List: get a file list of a remote directory (on the FTP server)
034104060703      *            (filenames only)
034105060703      *
034106060703      *   peHandle   = session handle returned by FTP_Conn() or FTP_Open()
034107060703      *   peRmtPath  = remote path, used for NLISt command; usually generic
034108060703      *                something like '*.txt' or '/windows/*.exe'
034109060703      *   peMaxCount = max number of directory entries to return
034110060703      *              = (usually the actual array size)
034111060703      *   peDirList  = pointer to an array; each filename in the remote dir
034112060703      *                returned by the server will be placed into this
034113060703      *                array, up to the max number of entries (above)
034114060703      *   peRmtCount = actual number of  elements that could have been returned
034115060703      *                (could be larger than peMaxCount; increase array size)
034116060703      *
034117060703      *  returns 0 upon success or -1 upon error
034118060703      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034119060703     P FTP_List        B                   export
034120060703     D FTP_List        PI            10I 0
034121060703     D   peHandle                    10I 0 value
034122060703     D   peRmtPath                  256A   const
034123060703     D   peMaxCount                  10I 0 value
034124060703     D   peDirList                     *   value
034125060703     D   peRmtCount                  10I 0
034126060703
034127060703     D wSessPtr        S               *
034128060703     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
034129060703
034130060703     D rc              S             10I 0
034131060703      *-------------------------------------------------------------------------
034133060703      /free
034134060703
034135060703       wSessPtr = GetActSession(peHandle);
034136060703       if (wSessPtr = *NULL);
034137060703         SetError(wSession: FTP_BADHDL: cErrBadHandle);
034138060703         return -1;
034139060703       endif;
034140060703
034141060703       // store & init the parameters in the session record
034142060703       wSession.DirArrPtr = peDirList;
034143060703       wSession.DirMaxCnt = peMaxCount;
034144060703       wSession.DirRmtCnt = 0;
034145060703
034146060703       // call the actual LIST procedure
034147060703       rc = FTP_LstRaw(peHandle: peRmtPath: peHandle: %paddr('LIST2ARRAY'));
034148060703
034149060703       peRmtCount = wSession.DirRmtCnt;
034150060703       return rc;
034151060703
034152060703      /end-free
034153060703     P                 E
034154060703
034155060703
034156060703      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034157060703      * FTP_LstRaw: get a file list of a remote directory (on the FTP server)
034158060703      *             (filenames only)
034159060703      *             storage of the result list is handled by peFunction
034160060703      *
034161060703      *   peHandle   = session handle returned by FTP_Conn() or FTP_Open()
034162060703      *   peRmtPath  = remote path, used for NLISt command; usually generic
034163060703      *                something like '*.txt' or '/windows/*.exe'
034164060703      *   peDescr    = descriptor to pass to peFunction below
034165060703      *                (if peFunction writes to a file, that would the file descr
034166060703      *                of the open file to write the output to; when using
034167060703      *                List2Array, it is actually the session handle)
034168060703      *   peFunction = procedure to store each line of the directory list
034169060703      *
034170060703      *  returns 0 upon success or -1 upon error
034171060703      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034172060703     P FTP_LstRaw      B                   export
034173060703     D FTP_LstRaw      PI            10I 0
034174060703     D   peHandle                    10I 0 value
034175060703     D   peRmtPath                  256A   const
034176060703     D   peDescr                     10I 0 value
034177060703     D   peFunction                    *   value procptr
034178060703
034179060703     D wSessPtr        S               *
034180060703     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
034181060703
034182060703     D wReply          S             10I 0
034184060703     D wReplyStr       S                   like(TReplyStr)
034185060703     D wCD             DS                  likeds(TIconv)
034186060703     D rc              S             10I 0
034187060703
034188060703      /if not defined(*V5R2M0)
034189060703     D pCDLclCtrl      S               *
034190060703     D wCDLclCtrl      DS                  likeds(TIconv) based(pCDLclCtrl)
034191060703      /endif
034192060703      *-------------------------------------------------------------------------
034193060703      /free
034194060703
034195060703       wSessPtr = GetActSession(peHandle);
034196060703       if (wSessPtr = *NULL);
034197060703         SetError(wSession: FTP_BADHDL: cErrBadHandle);
034198060703         return -1;
034199060703       endif;
034200060703
034201060704       // open the data channel
034202060704       if (wSession.UsePASV);
034203060704         rc = ConnectPASV(wSession);
034204060704       else;
034205060704         // XXX rc = ConnectPORT(wSession);
034206060704       endif;
034207060704
034208060704       if (rc < 0);
034209060704         return -1;
034210060704       endif;
034211060704
034212060704       // ask the server for the directory listing
034213060705       if (SendLine(wSession: 'NLST ' + peRmtPath) < 0);
034214060704         return CloseData(wSession);
034216060703       endif;
034217060703
034218060704       // let's see what the server thinks about our request
034219060703       wReply = Reply(wSession: wReplyStr);
034220060704       select;
034221060704       when (wReply < 0);
034223060704         return CloseData(wSession);
034224060704       when (wReply = 550);
034227060704         // no such files on this server
034228060704         SetError(wSession: FTP_NOFILE: wReplyStr);
034229060704         return CloseData(wSession);
034230060704       when (wReply <> 150) and (wReply <> 125);
034232060704         // something really bad happened, like the path was malformed
034233060704         SetError(wSession: FTP_BADNLS: wReplyStr);
034234060704         return CloseData(wSession);
034235060704       endsl;
034237060704
034238060704       // directory listings happen on the data channel, but use the CCSID
034239060704       // of the control channel; oh yeah, FTP really is a PITA
034240060703      /if defined(*V5R2M0)
034241060703       wCD = wSession.CDLclCtrl;
034242060703      /else
034243060703       pCDLclCtrl = %addr(wSession.CDLclCtrl);
034244060703       wCD = wCDLclCtrl;
034245060703      /endif
034246060704       wSession.DataCRLF = CRLF;
034247060704
034249060704       // let our trusted transfer procedure do the grunt work
034250060705       rc = XferDataChunk(wSession: %paddr(RECVDATALINE): peHandle:
034251060704              %paddr(LIST2ARRAY): peHandle: wCD);
034252060703
034253060704       if (rc < 0);
034254060705         Reply(wSession);
034255060705         return -1;
034256060704       endif;
034257060704
034258060704       // what does the server think about the file transfer?
034259060704       wReply = Reply(wSession: wReplyStr);
034260060704       select;
034261060704       when (wReply < 0);
034262060704         return -1;
034263060704       when (wReply <> 226) and (wReply <> 250);
034264060704         SetError(wSession: FTP_XFRERR: wReplyStr);
034265060704         return -1;
034266060704       endsl;
034267060704
034268060704       return 0;
034269060704
034270060703      /end-free
034271060703     P                 E
034272060703
034273060705
034274060705      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034275060705      *  FTP_BinaryMode: set file transfer mode to/from binary mode
034276060705      *
034277060705      *  peHandle   = session handle returned by FTP_Conn() or FTP_Open()
034278060705      *  peSetting  = setting of binary mode *ON  = turn binary mode on
034279060705      *                                      *OFF = turn binary mode off
034280060705      *
034281060705      *  returns 0 upon success or -1 upon error
034282060705      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034283060705     P FTP_BinaryMode  B                   export
034284060705     D FTP_BinaryMode  PI            10I 0
034285060705     D   peHandle                    10I 0 value
034286060705     D   peSetting                     N   value
034287060705
034288060705     D wSessPtr        S               *
034289060705     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
034290060705      *-------------------------------------------------------------------------
034291060705      /free
034292060705
034293060705       wSessPtr = GetActSession(peHandle);
034294060705       if (wSessPtr = *NULL);
034295060705         SetError(wSession: FTP_BADHDL: cErrBadHandle);
034296060705         return -1;
034297060705       endif;
034298060705
034299060705       wSession.Binary = peSetting;
034300060705       return 0;
034301060705
034302060705      /end-free
034303060705     P                 E
034304060705
034305060704
034306060705
034307060705      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034308060705      *  FTP_ChDir: change current directory on FTP server
034309060705      *
034310060705      *  peHandle   = session handle returned by FTP_Conn() or FTP_Open()
034311060705      *  peChgDir   = directory to change to
034312060705      *
034313060705      *  returns 0 upon success or -1 upon error
034314060705      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034315060705     P FTP_ChDir       B                   export
034316060705     D FTP_ChDir       PI            10I 0
034317060705     D   peHandle                    10I 0 value
034318060705     D   peChgDir                   256A   const
034319060705
034320060705     D wSessPtr        S               *
034321060705     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
034322060705
034323060705     D wReply          S             10I 0
034324060705     D wReplyStr       S                   like(TReplyStr)
034325060705     D rc              S             10I 0
034326060705      *-------------------------------------------------------------------------
034327060705      /free
034328060705
034329060705       wSessPtr = GetActSession(peHandle);
034330060705       if (wSessPtr = *NULL);
034331060705         SetError(wSession: FTP_BADHDL: cErrBadHandle);
034332060705         return -1;
034333060705       endif;
034334060705
034335060705       if (peChgDir = '..');
034336060705         rc = SendLine(wSession: 'CDUP');
034337060705        else;
034338060705         rc = SendLine(wSession: 'CWD ' + peChgDir);
034339060705       endif;
034340060705
034341060705       // what does the server think about the file transfer?
034342060705       wReply = Reply(wSession: wReplyStr);
034343060705       select;
034344060705       when (wReply < 0);
034345060705         return -1;
034346060705       when (wReply <> 200) and (wReply <> 299);
034347060705         SetError(wSession: FTP_ERRCWD: wReplyStr);
034348060705         return -1;
034349060705       endsl;
034350060705
034351060705       return 0;
034352060705
034353060705      /end-free
034354060705     P                 E
034355060705
034356060705
034357060704      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034358060704      *  FTP_CodePage: set file translation CCSIDs for ASCII mode
034359060704      *
034360060704      *  peHandle   = session handle returned by FTP_Conn() or FTP_Open()
034361060704      *  peRmtCCSID = CCSID of the remote server
034362060704      *  peLclCCSID = CCSID of the local host
034363060704      *
034364060704      *  returns 0 upon success or -1 upon error
034365060704      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034366060704     P FTP_CodePage    B                   export
034367060704     D FTP_CodePage    PI            10I 0
034368060704     D   peHandle                    10I 0 value
034369060704     D   peRmtCCSID                  10I 0 value
034370060704     D   peLclCCSID                  10I 0 value
034371060704
034372060704     D wSessPtr        S               *
034373060704     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
034374060704      *-------------------------------------------------------------------------
034375060704      /free
034376060704
034377060704       wSessPtr = GetActSession(peHandle);
034378060704       if (wSessPtr = *NULL);
034379060704         SetError(wSession: FTP_BADHDL: cErrBadHandle);
034380060704         return -1;
034381060704       endif;
034382060704
034383060704       ChgDataCCSID(wSession: peLclCCSID: peRmtCCSID);
034384060704       return 0;
034385060704
034386060704      /end-free
034387060704     P                 E
034388060704
034389060704
034390060704      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034391060704      *  FTP_Get: retrieve a file from a FTP server
034392060704      *
034393060704      *   peHandle   = session handle returned by FTP_Conn() or FTP_Open()
034394060704      *   peRmtPath  = remote file name (on server)
034395060704      *   peLclPath  = local file name ("NAMEFMT 1")
034396060704      *                (can be omitted for backwards compatibility)
034397060704      *
034398060704      *  returns 0 upon success or -1 upon error
034399060704      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034400060704     P FTP_Get         B                   export
034401060704     D FTP_Get         PI            10I 0
034402060704     D   peHandle                    10I 0 value
034403060704     D   peRmtPath                  256A   const
034404060704     D   peLclPath                  256A   const options(*nopass)
034405060704
034406060704     D wSessPtr        S               *
034407060704     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
034408060704
034409060704     D wLclPath        S                   like(peLclPath)
034410060704     D wReply          S             10I 0
034411060704     D wReplyStr       S                   like(TReplyStr)
034412060704     D wCD             DS                  likeds(TIconv)
034413060704     D rc              S             10I 0
034414060704
034415060704      /if not defined(*V5R2M0)
034416060704     D pCDLclData      S               *
034417060704     D wCDLclData      DS                  likeds(TIconv) based(pCDLclData)
034418060704      /endif
034419060704      *-------------------------------------------------------------------------
034420060704      /free
034421060704
034422060704       wSessPtr = GetActSession(peHandle);
034423060704       if (wSessPtr = *NULL);
034424060704         SetError(wSession: FTP_BADHDL: cErrBadHandle);
034425060704         return -1;
034426060704       endif;
034427060704
034428060704       // set the working local path name
034429060704       if (%parms >= 3);
034430060704         wLclPath = peLclPath;
034431060704       else;
034432060704         wLclPath = peRmtPath;
034433060704       endif;
034434060704
034435060704       // open the local file first (no need to bother the server, if we fail)
034436060704       wSession.FileDescr = OpenFileWrite(wSession: wLclPath);
034437060704       if (wSession.FileDescr < 0);
034438060704         return -1;
034439060704       endif;
034440060704
034441060704       // open the data channel
034442060704       if (wSession.UsePASV);
034443060704         rc = ConnectPASV(wSession);
034444060704       else;
034445060704         // XXX rc = ConnectPORT(wSession);
034446060704       endif;
034447060704
034448060704       if (rc < 0);
034449060704         return -1;
034450060704       endif;
034451060704
034452060704       // ask the server for the file to be retrieved
034453060705       if (SendLine(wSession: 'RETR ' + peRmtPath) < 0);
034454060704         return CloseData(wSession);
034455060704       endif;
034456060704
034457060704       // let's see what the server thinks about our request
034458060704       wReply = Reply(wSession: wReplyStr);
034459060704       select;
034460060704       when (wReply < 0);
034461060704         return CloseData(wSession);
034462060704       when (wReply <> 150) and (wReply <> 125);
034463060704         // maybe path was wrong or does not exist
034464060704         SetError(wSession: FTP_BADRTR: wReplyStr);
034465060704         return CloseData(wSession);
034466060704       endsl;
034467060704
034468060704      /if defined(*V5R2M0)
034469060704       wCD = wSession.CDLclData;
034470060704      /else
034471060704       pCDLclData = %addr(wSession.CDLclData);
034472060704       wCD = wCDLclData;
034473060704      /endif
034474060704
034475060705       // let our trusted transfer procedures do the grunt work
034476060705       select;
034477060705       when (wSession.Binary);
034478060705         rc = XferDataBinary(wSession: %paddr(RECVDATASTRM): peHandle:
034479060705                %paddr(IF_WRITE): wSession.FileDescr);
034480060705
034481060705       other;
034482060705         rc = XferDataAscii(wSession: %paddr(RECVDATASTRM): peHandle:
034483060705                %paddr(IF_WRITE): wSession.FileDescr: wCD);
034484060705       endsl;
034485060704
034486060704       // set the file CCSID, no matter how successful; don't care if it fails
034487060704       if not wSession.Binary;
034488060704         SetFileCCSID(%trimr(wLclPath): wSession.LclCCSID);
034489060704       endif;
034490060704
034491060704       if (rc < 0);
034492060705         Reply(wSession);
034493060705         return -1;
034494060704       endif;
034495060704
034496060704       // what does the server think about the file transfer?
034497060704       wReply = Reply(wSession: wReplyStr);
034498060704       select;
034499060704       when (wReply < 0);
034500060704         return -1;
034501060704       when (wReply <> 226) and (wReply <> 250);
034502060704         SetError(wSession: FTP_XFRERR: wReplyStr);
034503060704         return -1;
034504060704       endsl;
034505060704
034506060704       return 0;
034507060704
034508060704      /end-free
034509060704     P                 E
034510060704
034511060705
034512060705      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034513060705      *  FTP_Put: send a file to a FTP server
034514060705      *
034515060705      *   peHandle   = session handle returned by FTP_Conn() or FTP_Open()
034516060705      *   peRmtPath  = remote file name (on server)
034517060705      *   peLclPath  = local file name ("NAMEFMT 1")
034518060705      *                (can be omitted for backwards compatibility)
034519060705      *
034520060705      *  returns 0 upon success or -1 upon error
034521060705      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034522060705     P FTP_Put         B                   export
034523060705     D FTP_Put         PI            10I 0
034524060705     D   peHandle                    10I 0 value
034525060705     D   peRmtPath                  256A   const
034526060705     D   peLclPath                  256A   const options(*nopass)
034527060705
034528060705     D wSessPtr        S               *
034529060705     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
034530060705
034531060705     D wLclPath        S                   like(peLclPath)
034532060705     D wReply          S             10I 0
034533060705     D wReplyStr       S                   like(TReplyStr)
034534060705     D wCD             DS                  likeds(TIconv)
034535060705     D rc              S             10I 0
034536060705
034537060705      /if not defined(*V5R2M0)
034538060705     D pCDRmtData      S               *
034539060705     D wCDRmtData      DS                  likeds(TIconv) based(pCDRmtData)
034540060705      /endif
034541060705      *-------------------------------------------------------------------------
034542060705      /free
034543060705
034544060705       wSessPtr = GetActSession(peHandle);
034545060705       if (wSessPtr = *NULL);
034546060705         SetError(wSession: FTP_BADHDL: cErrBadHandle);
034547060705         return -1;
034548060705       endif;
034549060705
034550060705       // set the working local path name
034551060705       if (%parms >= 3);
034552060705         wLclPath = peLclPath;
034553060705       else;
034554060705         wLclPath = peRmtPath;
034555060705       endif;
034556060705
034557060705       // open the local file first (no need to bother the server, if we fail)
034558060705       wSession.FileDescr = OpenFileRead(wSession: wLclPath);
034559060705       if (wSession.FileDescr < 0);
034560060705         return -1;
034561060705       endif;
034562060705
034563060705       // open the data channel
034564060705       if (wSession.UsePASV);
034565060705         rc = ConnectPASV(wSession);
034566060705       else;
034567060705         // XXX rc = ConnectPORT(wSession);
034568060705       endif;
034569060705
034570060705       if (rc < 0);
034571060705         return -1;
034572060705       endif;
034573060705
034574060705       // ask the server to store the file
034575060705       if (SendLine(wSession: 'STOR ' + peRmtPath) < 0);
034576060705         return CloseData(wSession);
034577060705       endif;
034578060705
034579060705       // let's see what the server thinks about our request
034580060705       wReply = Reply(wSession: wReplyStr);
034581060705       select;
034582060705       when (wReply < 0);
034583060705         return CloseData(wSession);
034584060705       when (wReply <> 150) and (wReply <> 125);
034585060705         // maybe path was wrong or does not exist
034586060705         SetError(wSession: FTP_BADSTO: wReplyStr);
034587060705         return CloseData(wSession);
034588060705       endsl;
034589060705
034590060705      /if defined(*V5R2M0)
034591060705       wCD = wSession.CDRmtData;
034592060705      /else
034593060705       pCDRmtData = %addr(wSession.CDRmtData);
034594060705       wCD = wCDRmtData;
034595060705      /endif
034596060705
034597060705       // let our trusted transfer procedures do the grunt work
034599060705       select;
034600060705       when (wSession.Binary);
034601060705         rc = XferDataBinary(wSession: %paddr(IF_READ): wSession.FileDescr:
034602060705                %paddr(SENDDATASTRM): peHandle);
034603060705
034604060705       other;
034605060705         rc = XferDataAscii(wSession: %paddr(IF_READ): wSession.FileDescr:
034606060705                %paddr(SENDDATASTRM): peHandle: wCD);
034607060705       endsl;
034608060705
034614060705       if (rc < 0);
034615060705         Reply(wSession);
034616060705         return -1;
034617060705       endif;
034618060705
034619060705       // what does the server think about the file transfer?
034620060705       wReply = Reply(wSession: wReplyStr);
034621060705       select;
034622060705       when (wReply < 0);
034623060705         return -1;
034624060705       when (wReply <> 226) and (wReply <> 250);
034625060705         SetError(wSession: FTP_XFRERR: wReplyStr);
034626060705         return -1;
034627060705       endsl;
034628060705
034629060705       return 0;
034630060705
034635060705      /end-free
034636060705     P                 E
034637060705
034638060703
034639060703      *++FTP_MTime++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034640060630      *  FTP_mtime: get modification time of a file on a FTP server
034641060630      *
034642060630      * NOTE: this is not part of the official FTP standard, and is not
034643060630      *       supported by some FTP servers, INCLUDING THE AS/400 FTP SERVER
034644060630      *
034645060630      *   peHandle = session handle returned by FTP_Conn() or FTP_Open()
034646060630      *     peFile = file to look up the size of
034647060630      *  peModTime = Modification time returned by server
034648060630      *
034649060630      *  returns 0 upon success or -1 upon error
034650060630      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034651060703     P FTP_MTime       B                   export
034652060707     D FTP_MTime       PI            10I 0
034653060630     D   peHandle                    10I 0 value
034654060630     D   peFile                     256A   const
034655060630     D   peModTime                     Z
034656060630
034657060630     D wSessPtr        S               *
034658060630     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
034659060630
034660060630     D wReply          S             10I 0
034661060630     D wReplyStr       S                   like(TReplyStr)
034662060707      *-------------------------------------------------------------------------
034665060630      /free
034666060630
034667060630       wSessPtr = GetActSession(peHandle);
034668060630       if (wSessPtr = *NULL);
034669060630         SetError(wSession: FTP_BADHDL: cErrBadHandle);
034670060630         return -1;
034671060630       endif;
034672060630
034673060707       // server never claimed that it supports this command
034674060630       if not wSession.CanMDTM;
034675060630         SetError(wSession: FTP_MODERR: cErrMDTMCannot);
034676060630         return -1;
034677060630       endif;
034678060630
034679060707       // ask the server for modification date/time
034680060707       if (SendLine(wSession: 'MDTM ' + peFile) < 0);
034681060630         return -1;
034682060630       endif;
034683060630
034684060707       // 213 YYYYMMDDHHMMSS
034685060707       wReply = Reply(wSession: wReplyStr);
034686060630       select;
034687060630       when (wReply < 0);
034688060630         return -1;
034689060630       when (wReply <> 213);
034690060630         SetError(wSession: FTP_MODERR: wReplyStr);
034691060630         return -1;
034692060630       endsl;
034693060630
034694060707       monitor;
034695060707         peModTime = %timestamp(wReplyStr: *ISO0);
034698060707       on-error;
034699060707         peModTime = *LOVAL;
034700060707         SetError(wSession: FTP_MODPRS: cErrParseMDTM);
034701060707       endmon;
034702060707
034703060630       return 0;
034704060630
034705060630      /end-free
034706060630     P                 E
034707060630
034708060705
034709060705      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034710060705      *  FTP_ErrorMsg: returns the error message that occurred when one of the
034711060705      *  above routines returned failure
034712060705      *
034713060705      *  peHandle   = session handle returned by FTP_Conn() or FTP_Open()
034714060705      *  peErrorNum = numerical error code
034715060705      *
034716060705      *  optionally also returns the error number, which will match one of the
034717060705      *  constants defined in FTPAPI_H. This can be used by programs to
034718060705      *  anticipate/handle errors
034719060705      *
034720060705      *  NOTE: this will actually return the last error stored, even if the last
034721060705      *        call to an API procedure has been successful; thus call early!
034722060705      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034723060705     P FTP_ErrorMsg    B                   export
034724060705     D FTP_ErrorMsg    PI            60A
034725060705     D   peHandle                    10I 0 value
034726060705     D   peErrorNum                  10I 0 options(*nopass)
034727060705
034728060705     D wSessPtr        S               *
034729060705     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
034730060705      *-------------------------------------------------------------------------
034731060705      /free
034732060705
034733060705       wSessPtr = GetActSession(peHandle);
034734060705       if (wSessPtr = *NULL);
034735060705         SetError(wSession: FTP_BADHDL: cErrBadHandle);
034736060705         return *BLANKS;
034737060705       endif;
034738060705
034739060705       if (%parms >= 2);
034740060705         peErrorNum = wSession.Error;
034741060705       endif;
034742060705       return wSession.ErrorStr;
034743060705
034744060705      /end-free
034745060705     P                 E
034746060705
034747060623
034748060623      *#########################################################################
034749060623      *  local procedures
034750060623      *#########################################################################
034751060623
034752060623      *++CreateSession++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034800060623      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
034900060623     P CreateSession   B
035000060623     D CreateSession   PI            10I 0
035100060623
035200060629     D wSessPtr        S               *
035300060629     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
035400060623
035500060627     D Delta           C                   1
035600060623     D I               S             10I 0
035700060623     D OldSessionCnt   S             10I 0
035800060623     D NewSessionCnt   S             10I 0
035801060629
035802060703      /if not defined(*V5R2M0)
035803060629     D pCDRmtCtrl      S               *
035804060629     D pCDLclCtrl      S               *
035805060703     D wCDRmtCtrl      DS                  likeds(TIconv) based(pCDRmtCtrl)
035808060629     D wCDLclCtrl      DS                  likeds(TIconv) based(pCDLclCtrl)
035809060703     D pCDRmtData      S               *
035810060703     D pCDLclData      S               *
035811060703     D wCDRmtData      DS                  likeds(TIconv) based(pCDRmtData)
035812060703     D wCDLclData      DS                  likeds(TIconv) based(pCDLclData)
035813060703      /endif
035814060629      *-------------------------------------------------------------------------
036000060623      /free
036100060623
036200060623       // let's find a free entry in the session array
036300060623       for I = 0 to SessionCnt - 1;
036400060629         wSessPtr = (SessionPtr + I * %Size(TSessionRec));
036401060629         if (wSession.Socket < 0);
036501060629           // found a free session
036502060629           exsr InitSession;
036503060627           return I;
036700060623         endif;
036800060623       endfor;
036900060623
037000060623       // no more free entries -> expand array
037100060623       OldSessionCnt = SessionCnt;
037200060623       NewSessionCnt = SessionCnt + Delta;
037300060623
037400060623       if (SessionCnt = 0);
037500060623         SessionPtr = %alloc(%Size(TSessionRec) * NewSessionCnt);
037600060623       else;
037700060623         SessionPtr = %realloc(SessionPtr: %Size(TSessionRec) * NewSessionCnt);
037800060623       endif;
037900060623
038000060623       // initialize the new array entries
038100060623       for I = OldSessionCnt to SessionCnt;
038200060629         wSessPtr = (SessionPtr + I * %Size(TSessionRec));
038201060626         // Session = *allx'00';
038202060629         wSession.Handle = I;
038300060629         wSession.Socket = -1;
038301060629         wSession.Timeout = 0;
038302060704         wSession.DataSocket = -1;
038303060704         wSession.CtrlBLen = 0;
038305060703         wSession.DataBLen = 0;
038306060704         wSession.ClosePtr = *NULL;
038307060704         wSession.FileDescr = -1;
038308060704         wSession.EmptyLine = False;
038309060704         wSession.CanUTF8 = False;
038310060630         wSession.CanSSL = False;
038311060630         wSession.CanTLS = False;
038312060630         wSession.CanMDTM = False;
038313060630         wSession.CanSIZE = False;
038314060704         wSession.UsePASV = True;
038315060704         wSession.Binary = False;
038316060704         wSession.Error = 0;
038318060629         wSession.ErrorStr = '';
038319060626
038320060629      /if defined(*V5R2M0)
038321060629         wSession.CDRmtCtrl.return_value = -1;
038322060629         wSession.CDLclCtrl.return_value = -1;
038323060703         wSession.CDRmtData.return_value = -1;
038324060703         wSession.CDLclData.return_value = -1;
038325060703      /else
038326060629         pCDRmtCtrl = %addr(wSession.CDRmtCtrl);
038327060629         pCDLclCtrl = %addr(wSession.CDLclCtrl);
038328060629         wCDRmtCtrl.return_value = -1;
038329060629         wCDLclCtrl.return_value = -1;
038330060703         pCDRmtData = %addr(wSession.CDRmtData);
038331060703         pCDLclData = %addr(wSession.CDLclData);
038332060703         wCDRmtData.return_value = -1;
038333060703         wCDLclData.return_value = -1;
038334060703      /endif
038335060629
038336060627       endfor;
038500060623
038600060623       SessionCnt = NewSessionCnt;
038601060627
038700060629       wSessPtr = (SessionPtr + OldSessionCnt * %Size(TSessionRec));
038702060627       exsr InitSession;
038703060627
038800060623       // return the first one of the new entries
038900060623       return OldSessionCnt;
039000060623
039001060627
039002060627       // ----------------------------------------------------------------------
039003060627       begsr InitSession;
039004060627
039005060627         // let's get conversion descriptors
039006060704         ChgCtrlCCSID(wSession: DFT_LCL_CP: DFT_RMT_CP);
039025060704         ChgDataCCSID(wSession: DFT_LCL_CP: DFT_RMT_CP);
039026060704
039027060627       endsr;
039028060627
039100060623      /end-free
039200060623     P                 E
039300060623
039400060623
039500060623      *++GetSessionPtr++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
039600060623      *  gets the pointer to the actual session data for the supplied handle
039700060626      *  if the handle is out of range, we'll return *NULL
039800060626      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
040000060623     P GetSessionPtr   B
040100060623     D GetSessionPtr   PI              *
040200060627     D   iHandle                     10I 0 value
040201060627
040400060629     D wSessPtr        S               *
040500060626      *-------------------------------------------------------------------------
040700060623      /free
040800060623
040900060623       if (iHandle >= 0) and (iHandle < SessionCnt);
041000060629         wSessPtr = (SessionPtr + iHandle * %Size(TSessionRec));
041100060626       endif;
041500060623
041600060629       return wSessPtr;
041700060623
041800060623      /end-free
041900060623     P                 E
042000060623
042001060626
042002060626      *++GetActSession++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
042003060626      *  gets the pointer to the actual session data for the supplied handle
042004060626      *  if the handle is out of range or points to an inactive session, we'll
042005060626      *  return *NULL
042006060626      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
042007060626     P GetActSession   B
042008060626     D GetActSession   PI              *
042009060627     D   iHandle                     10I 0 value
042010060627
042011060629     D wSessPtr        S               *
042012060629     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
042013060626      *-------------------------------------------------------------------------
042014060626      /free
042015060626
042016060629       wSessPtr = GetSessionPtr(iHandle);
042018060629       if (wSessPtr <> *NULL) and (wSession.Socket < 0);
042019060629         wSessPtr = *NULL;
042020060626       endif;
042021060626
042023060629       return wSessPtr;
042024060626
042025060626      /end-free
042026060626     P                 E
042027060626
042100060623
042200060623      *++ReleaseSession+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
042300060623      *  releases the session record for the supplied session handle
042400060623      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
042500060623     P ReleaseSession  B
042600060623     D ReleaseSession  PI
042700060627     D   iHandle                     10I 0 value
042701060627
042900060629     D wSessPtr        S               *
043000060629     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
043100060629
043101060703      /if not defined(*V5R2M0)
043102060703     D pCDRmtCtrl      S               *
043103060629     D pCDLclCtrl      S               *
043104060629     D wCDRmtCtrl      DS                  likeds(TIconv) based(pCDRmtCtrl)
043105060629     D wCDLclCtrl      DS                  likeds(TIconv) based(pCDLclCtrl)
043106060703     D pCDRmtData      S               *
043107060703     D pCDLclData      S               *
043108060703     D wCDRmtData      DS                  likeds(TIconv) based(pCDRmtData)
043109060703     D wCDLclData      DS                  likeds(TIconv) based(pCDLclData)
043110060703      /endif
043111060703      *-------------------------------------------------------------------------
043200060623      /free
043300060623
043400060629       wSessPtr = GetSessionPtr(iHandle);
043500060704       if (wSessPtr = *NULL);
043501060704         return;
043502060704       endif;
043503060704
043504060704       wSession.Socket = -1;
043601060704       ChgCtrlCCSID(wSession: -1: -1);
043602060704       ChgDataCCSID(wSession: -1: -1);
043603060704
043604060704      /if defined(FALSE)
043605060704      /if defined(*V5R2M0)
043606060629         Iconv_Close(wSession.CDRmtCtrl);
043700060629         Iconv_Close(wSession.CDLclCtrl);
043701060703         Iconv_Close(wSession.CDRmtData);
043702060703         Iconv_Close(wSession.CDLclData);
043703060703      /else
043704060629         pCDRmtCtrl = %addr(wSession.CDRmtCtrl);
043705060629         pCDLclCtrl = %addr(wSession.CDLclCtrl);
043706060629         Iconv_Close(wCDRmtCtrl);
043707060629         Iconv_Close(wCDLclCtrl);
043708060703         pCDRmtData = %addr(wSession.CDRmtData);
043709060703         pCDLclData = %addr(wSession.CDLclData);
043710060703         Iconv_Close(wCDRmtData);
043711060703         Iconv_Close(wCDLclData);
043712060703      /endif
043713060704      /endif
043714060704
043900060623      /end-free
044000060623     P                 E
044100060623
044382060626
044383060629      *++ChgCtrlCCSID+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044384060629      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044385060629     P ChgCtrlCCSID    B
044386060629     D ChgCtrlCCSID    PI
044387060629     D   aSession                          likeds(TSessionRec)
044388060629     D   iLclCCSID                   10I 0 value
044389060629     D   iRmtCCSID                   10I 0 value
044390060629
044391060703      /if not defined(*V5R2M0)
044392060629     D pCDRmtCtrl      S               *
044393060629     D pCDLclCtrl      S               *
044394060629     D wCDRmtCtrl      DS                  likeds(TIconv) based(pCDRmtCtrl)
044395060629     D wCDLclCtrl      DS                  likeds(TIconv) based(pCDLclCtrl)
044396060703      /endif
044397060629      *-------------------------------------------------------------------------
044398060629      /free
044399060629
044400060629      /if defined(*V5R2M0)
044401060704       if (aSession.CDRmtCtrl.return_value >= 0);
044402060704         Iconv_Close(aSession.CDRmtCtrl);
044403060704         aSession.CDRmtCtrl.return_value = -1;
044404060704       endif;
044405060704
044406060704       if (aSession.CDLclCtrl.return_value >= 0);
044407060704         Iconv_Close(aSession.CDLclCtrl);
044408060704         aSession.CDLclCtrl.return_value = -1;
044409060704       endif;
044410060704
044411060704       if (iRmtCCSID = -1) and (iLclCCSID = -1);
044412060704         return;
044413060704       endif;
044414060704
044415060704       CreateCD(aSession.CDRmtCtrl: iLclCCSID: iRmtCCSID); // lcl -> rmt
044416060704       CreateCD(aSession.CDLclCtrl: iRmtCCSID: iLclCCSID); // rmt -> lcl
044417060704
044418060629      /else
044419060704       pCDRmtCtrl = %addr(aSession.CDRmtCtrl);
044420060704       pCDLclCtrl = %addr(aSession.CDLclCtrl);
044421060704
044422060704       if (wCDRmtCtrl.return_value >= 0);
044423060704         Iconv_Close(wCDRmtCtrl);
044424060704         wCDRmtCtrl.return_value = -1;
044425060704       endif;
044426060704
044427060704       if (wCDLclCtrl.return_value >= 0);
044428060704         Iconv_Close(wCDLclCtrl);
044429060704         wCDLclCtrl.return_value = -1;
044430060704       endif;
044431060704
044432060704       if (iRmtCCSID = -1) and (iLclCCSID = -1);
044433060704         return;
044434060704       endif;
044435060704
044436060704       CreateCD(wCDRmtCtrl: iLclCCSID: iRmtCCSID); // lcl -> rmt
044437060704       CreateCD(wCDLclCtrl: iRmtCCSID: iLclCCSID); // rmt -> lcl
044438060629      /endif
044439060629
044440060629      /end-free
044441060629     P                 E
044442060629
044443060704
044444060704      *++ChgDataCCSID+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044445060704      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044446060704     P ChgDataCCSID    B
044447060704     D ChgDataCCSID    PI
044448060704     D   aSession                          likeds(TSessionRec)
044449060704     D   iLclCCSID                   10I 0 value
044450060704     D   iRmtCCSID                   10I 0 value
044451060704
044452060704      /if not defined(*V5R2M0)
044453060704     D pCDRmtData      S               *
044454060704     D pCDLclData      S               *
044455060704     D wCDRmtData      DS                  likeds(TIconv) based(pCDRmtData)
044456060704     D wCDLclData      DS                  likeds(TIconv) based(pCDLclData)
044457060704      /endif
044458060704      *-------------------------------------------------------------------------
044459060704      /free
044460060704
044461060704      /if defined(*V5R2M0)
044462060704       if (aSession.CDRmtData.return_value >= 0);
044463060704         Iconv_Close(aSession.CDRmtData);
044464060704         aSession.CDRmtData.return_value = -1;
044465060704       endif;
044466060704
044467060704       if (aSession.CDLclData.return_value >= 0);
044468060704         Iconv_Close(aSession.CDLclData);
044469060704         aSession.CDLclData.return_value = -1;
044470060704       endif;
044471060704
044472060704       if (iLclCCSID <> iRmtCCSID);
044473060704         CreateCD(aSession.CDRmtData: iLclCCSID: iRmtCCSID); // lcl -> rmt
044474060704         CreateCD(aSession.CDLclData: iRmtCCSID: iLclCCSID); // rmt -> lcl
044475060704       endif;
044476060704      /else
044477060704       pCDRmtData = %addr(aSession.CDRmtData);
044478060704       pCDLclData = %addr(aSession.CDLclData);
044479060704
044480060704       if (wCDRmtData.return_value >= 0);
044481060704         Iconv_Close(wCDRmtData);
044482060704         wCDRmtData.return_value = -1;
044483060704       endif;
044484060704
044485060704       if (wCDLclData.return_value >= 0);
044486060704         Iconv_Close(wCDLclData);
044487060704         wCDLclData.return_value = -1;
044488060704       endif;
044489060704
044490060704       if (iLclCCSID <> iRmtCCSID);
044491060704         CreateCD(wCDRmtData: iLclCCSID: iRmtCCSID); // lcl -> rmt
044492060704         CreateCD(wCDLclData: iRmtCCSID: iLclCCSID); // rmt -> lcl
044493060704       endif;
044494060704      /endif
044495060704
044496060704       aSession.LclCCSID = iLclCCSID;
044497060704       aSession.RmtCCSID = iRmtCCSID;
044498060704
044499060704      /end-free
044500060704     P                 E
044501060704
044502060629
044503060626      *++SendLine+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044504060626      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044505060626     P SendLine        B
044506060626     D SendLine        PI            10I 0
044507060626     D   aSession                          likeds(TSessionRec)
044508060626     D   iLine                     1024A   value
044509060626
044510060629     D OutBuffer       S           2048A
044511060626     D InpPtr          S               *
044512060626     D OutPtr          S               *   inz(%addr(OutBuffer))
044513060626     D InpLen          S             10U 0
044514060626     D OutLen          S             10U 0 inz(%size(OutBuffer))
044515060705     D rcu             S             10U 0
044516060705     D wErrorStr       S                   like(TErrorStr)
044517060705     D rc              S             10I 0
044518060629
044519060703      /if not defined(*V5R2M0)
044520060629     D pCDRmtCtrl      S               *
044521060629     D wCDRmtCtrl      DS                  likeds(TIconv) based(pCDRmtCtrl)
044522060703      /endif
044523060629      *-------------------------------------------------------------------------
044524060626      /free
044525060626
044526060627       SndInfoMsg('> ' + iLine: aSession.Handle);
044527060627
044528060627       InpPtr = %addr(iLine);
044529060626       InpLen = %len(%trimr(iLine));
044530060629
044531060629      /if defined(*V5R2M0)
044532060629       rcu = iconv(aSession.CDRmtCtrl: InpPtr: InpLen: OutPtr: OutLen);
044533060629      /else
044534060629       pCDRmtCtrl = %addr(aSession.CDRmtCtrl);
044535060629       rcu = iconv(wCDRmtCtrl: InpPtr: InpLen: OutPtr: OutLen);
044536060629      /endif
044537060629
044538060626       OutLen = %Size(OutBuffer) - OutLen + 2;
044539060626       if (rcu = cMaxUnsigned) or (OutLen > %size(OutBuffer));
044540060629         SetError(aSession: FTP_ERRCONV: cErrConvCtrlToRmt);
044541060629         SndDiagMsg(aSession.ErrorStr: aSession.Handle);
044542060629         return -1;
044543060626       endif;
044544060626
044545060629       %subst(OutBuffer: OutLen - 1: 2) = CRLF;
044546060627       rc = TCP_Send(aSession.Socket: %addr(OutBuffer): OutLen:
044547060629         aSession.Timeout: wErrorStr);
044548060629       return AnalyzeResult(aSession: rc: wErrorStr: FTP_ERRSEND: cErrSendCtrl);
044549060626
044550060626      /end-free
044551060626     P                 E
044552060626
044553060626
044554060627      *++Reply++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044555060626      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044556060626     P Reply           B
044557060626     D Reply           PI            10I 0
044558060626     D   aSession                          likeds(TSessionRec)
044559060629     D   oResponse                         like(TReplyStr) options(*nopass)
044560060629
044561060626     D wReply          S             10I 0
044562060626     D wLine           S           1024A
044563060626     D wCode           S             10I 0
044564060626     D wSpace          S              1A
044565060626      *-------------------------------------------------------------------------
044566060626      /free
044567060626
044568060626       dou (wCode = wReply) and (wSpace = ' ');
044569060626         if (RecvLine(aSession: wLine) < 0);
044570060626           return -1;
044571060626         endif;
044572060626
044573060626         wCode = atoi(%subst(wLine: 1: 3));
044574060626         wSpace = %subst(wLine: 4: 1);
044575060626
044576060626         select;
044577060626         when (wReply = 0) and (wCode >= 100) and (%check(' -': wSpace) = 0);
044578060626           // first line well-formed
044579060626           wReply = wCode;
044580060626           if (%parms >= 2);
044581060626             oResponse = %subst(wLine: 5);
044582060626           endif;
044583060626
044584060626         when (wReply = 0);
044585060626           // first line mal-formed
044586060707           SetError(aSession: FTP_BADRES: cErrReplyMalformed);
044587060626           return -1;
044588060626         endsl;
044589060626       enddo;
044590060626
044591060626       return wCode;
044592060626
044593060626      /end-free
044594060626     P                 E
044595060626
044596060626
044597060627      *++RecvLine+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044598060626      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044599060626     P RecvLine        B
044600060626     D RecvLine        PI            10I 0
044601060626     D   aSession                          likeds(TSessionRec)
044602060626     D   oLine                     1024A
044603060627
044604060629     D wPos            S             10I 0
044605060627     D wRead           S             10I 0
044606060627     D wBuffPtr        S               *
044607060627     D wBuffLen        S             10I 0
044608060627     D ErrorStr        S                   like(TErrorStr)
044609060627
044610060627     D OutBuffer       S           2048A
044611060627     D InpPtr          S               *
044612060627     D OutPtr          S               *   inz(%addr(OutBuffer))
044613060627     D InpLen          S             10U 0
044614060627     D OutLen          S             10U 0 inz(%size(OutBuffer))
044615060627     D rcu             S             10U 0
044616060629
044617060703      /if not defined(*V5R2M0)
044618060629     D pCDLclCtrl      S               *
044619060629     D wCDLclCtrl      DS                  likeds(TIconv) based(pCDLclCtrl)
044620060703      /endif
044621060629      *-------------------------------------------------------------------------
044622060626      /free
044623060626
044624060629       dou (wPos <> 0) or (aSession.CtrlBLen = %size(aSession.CtrlBuff));
044625060704         // let's find the CRLF at the end of a line, if we got any data at all
044626060704         if (aSession.CtrlBLen > 0);
044627060629           wPos = %scan(CRLF: %subst(aSession.CtrlBuff: 1: aSession.CtrlBLen));
044628060629         endif;
044629060627
044630060704         // get more data from the control channel
044631060627         if (wPos = 0);
044632060627           wBuffPtr = %addr(aSession.CtrlBuff) + aSession.CtrlBLen;
044633060627           wBuffLen = %size(aSession.CtrlBuff) - aSession.CtrlBLen;
044634060627           wRead = TCP_Recv(aSession.Socket: wBuffPtr: wBuffLen:
044635060627             aSession.Timeout: ErrorStr);
044636060627
044637060704           select;
044638060704           when (wRead > 0);
044639060627             aSession.CtrlBLen = aSession.CtrlBLen + wRead;
044640060704           when (wRead = 0);
044641060704             // disconnected a bit prematurely
044642060704             return AnalyzeResult(aSession: teDisconnect: '':
044643060704               FTP_ERRRECV: cErrDiscCtrl);
044644060704           other;
044645060629             return AnalyzeResult(aSession: wRead: ErrorStr:
044646060629               FTP_ERRRECV: cErrRecvCtrl);
044647060704           endsl;
044648060627         endif;
044649060627       enddo;
044650060627
044651060627       if (wPos = 0);
044652060627         return -1;
044653060627       endif;
044654060627
044655060704       // we are interested in the data up to, but not including, the CRLF
044656060627       InpPtr = %addr(aSession.CtrlBuff);
044657060627       InpLen = wPos - 1;
044658060627
044659060704       // translate to the host CCSID
044660060629      /if defined(*V5R2M0)
044661060629       rcu = iconv(aSession.CDLclCtrl: InpPtr: InpLen: OutPtr: OutLen);
044662060629      /else
044663060629       pCDLclCtrl = %addr(aSession.CDLclCtrl);
044664060629       rcu = iconv(wCDLclCtrl: InpPtr: InpLen: OutPtr: OutLen);
044665060629      /endif
044666060629
044667060704       // either we have a CCSID problem or the resulting string does not fit
044668060629       OutLen = %Size(OutBuffer) - OutLen;
044669060627       if (rcu = cMaxUnsigned); // or (OutLen > %size(oLine));
044670060629         SetError(aSession: FTP_ERRCONV: cErrConvCtrlToLcl);
044671060629         SndDiagMsg(aSession.ErrorStr: aSession.Handle);
044672060629         return -1;
044673060629       endif;
044674060627
044675060704       // remove the obtained line from the receive buffer
044676060627       aSession.CtrlBuff = %subst(aSession.CtrlBuff: wPos + 2);
044677060627       aSession.CtrlBLen = aSession.CtrlBLen - wPos - 1;
044678060627
044679060704       // store the translated line in the out variable
044680060627       oLine = %subst(OutBuffer: 1: OutLen);
044681060704       SndInfoMsg(oLine: aSession.Handle);
044682060627       return 0;
044683060627
044684060626      /end-free
044685060626     P                 E
044686060626
044687060630
044688060630      *++GetFeatures++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044689060630      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044690060630     P GetFeatures     B
044691060630     D GetFeatures     PI            10I 0
044692060630     D   aSession                          likeds(TSessionRec)
044693060630
044694060630     D wReply          S             10I 0
044695060630     D wLine           S           1024A
044696060630     D wCode           S             10I 0
044697060630     D wSpace          S              1A
044698060630     D wFeature        S             10A   Varying
044699060630      *-------------------------------------------------------------------------
044700060630      /free
044701060630
044702060630       if (SendLine(aSession: 'FEAT') < 0);
044703060630         return -1;
044704060630       endif;
044705060630
044706060630       dou (wCode = wReply) and (wSpace = ' ');
044707060630         if (RecvLine(aSession: wLine) < 0);
044708060630           return -1;
044709060630         endif;
044710060630
044711060630         wCode = atoi(%subst(wLine: 1: 3));
044712060630         wSpace = %subst(wLine: 4: 1);
044713060630         wFeature = %xlate(LOWER: UPPER: wLine);
044714060630
044715060630         select;
044716060630         when (wReply = 0) and (wCode >= 100) and (%check(' -': wSpace) = 0);
044717060630           // first line well-formed
044718060630           wReply = wCode;
044719060630
044720060630         when (wReply = 0);
044721060630           // first line mal-formed
044722060630           return -1;
044723060630
044724060630         when (wReply = 211) and (wFeature = ' UTF8');
044725060630           aSession.CanUTF8 = True;
044726060630
044727060630         when (wReply = 211) and (wFeature = ' AUTH SSL');
044728060630           aSession.CanSSL = True;
044729060630
044730060630         when (wReply = 211) and (wFeature = ' AUTH TLS');
044731060630           aSession.CanTLS = True;
044732060630
044733060630         when (wReply = 211) and (wFeature = ' MDTM');
044734060630           aSession.CanMDTM = True;
044735060630
044736060630         when (wReply = 211) and (wFeature = ' SIZE');
044737060630           aSession.CanSIZE = True;
044738060630         endsl;
044739060630       enddo;
044740060630
044741060630       return wReply;
044742060630
044743060630      /end-free
044744060630     P                 E
044745060630
044746060626
044747060630      *++SetUTF8++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044748060630      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044749060630     P SetUTF8         B
044750060630     D SetUTF8         PI            10I 0
044751060630     D   aSession                          likeds(TSessionRec)
044752060630
044753060630     D wReply          S             10I 0
044754060630      *-------------------------------------------------------------------------
044755060630      /free
044756060630
044757060630       if not aSession.CanUTF8;
044758060630         return 0;
044759060630       endif;
044760060630
044761060630       if (SendLine(aSession: 'OPTS UTF8 ON') < 0);
044762060630         return -1;
044763060630       endif;
044764060630
044765060630       wReply = Reply(aSession);
044766060630       select;
044767060630       when (wReply < 0);
044768060630         return -1;
044769060630       when (wReply = 200);
044770060630         ChgCtrlCCSID(aSession: DFT_LCL_CP: 1208);
044771060630       endsl;
044772060630
044773060630       return 0;
044774060630
044775060630      /end-free
044776060630     P                 E
044777060630
044778060630
044779060703      *++ConnectPASV++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044780060703      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044781060703     P ConnectPASV     B
044782060703     D ConnectPASV     PI            10I 0
044783060703     D   aSession                          likeds(TSessionRec)
044784060703
044785060703     D sscanf          PR            10I 0 extproc('sscanf')
044786060703     D   iSrcStr                       *   value options(*string)
044787060703     D   iFmtStr                       *   value options(*string)
044788060703      * a variable number of output parameters, depending on format string,
044789060703      * will be added to the parameter list of this C function
044790060703     D   oUInt                       10U 0
044791060703     D   oUInt                       10U 0
044792060703     D   oUInt                       10U 0
044793060703     D   oUInt                       10U 0
044794060703     D   oUInt                       10U 0
044795060703     D   oUInt                       10U 0
044796060703
044797060703     D IP1             S             10U 0
044798060703     D IP2             S             10U 0
044799060703     D IP3             S             10U 0
044800060703     D IP4             S             10U 0
044801060703     D PortHi          S             10U 0
044802060703     D PortLo          S             10U 0
044803060703
044804060703     D cFmtStr         C                   '%u,%u,%u,%u,%u,%u'
044805060703     D wReply          S             10I 0
044806060703     D wReplyStr       S                   like(TReplyStr)
044807060703     D wPos            S             10I 0
044808060703     D wEnd            S             10I 0
044809060703     D PortStr         S             30A   varying
044810060703     D wHost           S            256A
044811060703     D wPort           S             10I 0
044812060703     D rc              S             10I 0
044813060703     D wSocket         S             10I 0
044814060703     D wErrorStr       S                   like(TErrorStr)
044815060703      *-------------------------------------------------------------------------
044816060703      /free
044817060703
044818060703       if (SendLine(aSession: 'PASV') < 0);
044819060703         return -1;
044820060703       endif;
044821060703
044822060703       // 227 Entering Passive Mode (127,0,0,1,195,89)
044823060703       wReply = Reply(aSession: wReplyStr);
044824060703       select;
044825060703       when (wReply < 0);
044826060703         return -1;
044827060703       when (wReply <> 227);
044828060703         SetError(aSession: FTP_PASERR: wReplyStr);
044829060703         return -1;
044830060703       endsl;
044831060703
044832060703       // extract the PORT/PASV string from the reply text
044833060703       wPos = %scan('(': wReplyStr);
044834060703       wEnd = %scan(')': wReplyStr);
044835060703
044836060703       // have to check or stupid RPG crashes
044837060703       if (wPos = 0) or (wEnd = 0) or (wEnd <= wPos);
044838060703         SetError(aSession: FTP_PASRPY: cErrPASVStr);
044839060707         SndDiagMsg(aSession.ErrorStr: aSession.Handle);
044840060707         return -1;
044841060703       endif;
044842060703
044843060703       // extract the comma seperated IP & port number
044844060703       PortStr = %subst(wReplyStr: wPos + 1: wEnd - wPos - 1);
044845060703
044846060703       // extract the six bytes from the PORT/PASV string
044847060703       if (sscanf(PortStr: cFmtStr: IP1: IP2: IP3: IP4: PortHi: PortLo) <> 6);
044848060703         SetError(aSession: FTP_PASRPY: cErrPASVStr);
044849060707         SndDiagMsg(aSession.ErrorStr: aSession.Handle);
044850060707         return -1;
044851060703       endif;
044852060703
044853060703       // build a dotted decimal IP address
044854060703       wHost = %char(IP1) + '.' + %char(IP2) + '.'
044855060703             + %char(IP3) + '.' + %char(IP4);
044856060703
044857060703       // calculate the port number
044858060703       wPort = PortHi * 256 + PortLo;
044859060703
044860060703       // finally ready to connect to remote server
044861060703       wSocket = TCP_Connect(wHost: wPort: aSession.Timeout: wErrorStr);
044862060703       if (wSocket < 0);
044863060703         return AnalyzeResult(aSession: wSocket: wErrorStr: FTP_ERRCON:
044864060703            cErrConnData);
044865060703       endif;
044866060703
044867060703       // shiny
044868060704       aSession.DataSocket = wSocket;
044869060704       return 0;
044870060703
044871060703      /end-free
044872060703     P                 E
044873060703
044874060703
044875060705      *++XferDataChunk++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044876060703      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044877060705     P XferDataChunk   B
044878060705     D XferDataChunk   PI            10I 0
044879060703     D   aSession                          likeds(TSessionRec)
044880060703     D   iRecvProc                     *   value procptr
044881060703     D   iRecvDescr                  10I 0
044882060703     D   iSendProc                     *   value procptr
044883060703     D   iSendDescr                  10I 0
044884060703     D   iCD                               const likeds(TIconv)
044885060703
044886060703     D RecvData        PR            10I 0 extproc(iRecvProc)
044887060703     D   iDescr                      10I 0 value
044888060703     D   iBuffer                  32766A   options(*varsize)
044889060703     D   iBufLen                     10I 0 value
044890060703
044891060703     D SendData        PR            10I 0 extproc(iSendProc)
044892060703     D   iDescr                      10I 0 value
044893060703     D   iBuffer                  32766A   options(*varsize)
044894060703     D   iBufLen                     10I 0 value
044895060703
044896060703     D nRead           S             10I 0
044897060703     D nSent           S             10I 0
044898060703
044899060703     D InpBuffer       S          65532A
044900060703     D OutBuffer       S          65532A
044901060703     D InpPtr          S               *
044902060703     D OutPtr          S               *   inz(%addr(OutBuffer))
044903060703     D InpLen          S             10U 0
044904060703     D OutLen          S             10U 0 inz(%size(OutBuffer))
044905060703     D rcu             S             10U 0
044906060703      *-------------------------------------------------------------------------
044907060703      /free
044908060703
044909060704       dow (1 = 1);
044910060703         // read a record or block
044911060703         nRead = RecvData(iRecvDescr: InpBuffer: %size(InpBuffer));
044912060703         select;
044913060703         when (nRead < 0);
044914060704           return CloseData(aSession);
044915060704
044916060704         when (nRead = 0) and (aSession.EmptyLine);
044917060704           // empty line; take a short cut
044918060704           aSession.EmptyLine = False;
044919060704           OutLen = 0;
044920060704
044921060704         when (nRead = 0);
044922060704           // we are done
044923060704           return 0;
044924060704
044925060704         other;
044926060704           // convert the data read
044927060704           InpPtr = %addr(InpBuffer);
044928060704           InpLen = nRead;
044929060704           OutPtr = %addr(OutBuffer);
044930060704           OutLen = %size(OutBuffer);
044931060704           rcu = iconv(iCD: InpPtr: InpLen: OutPtr: OutLen);
044932060704           OutLen = %size(OutBuffer) - OutLen;
044933060704
044934060704           if (rcu = cMaxUnsigned);
044935060704             return CloseData(aSession);
044936060704           endif;
044937060704         endsl;
044938060704
044939060703         // write the converted data
044940060704         nSent = SendData(iSendDescr: OutBuffer: OutLen);
044941060703
044942060703         if (nSent < 0);
044943060704           return CloseData(aSession);
044944060703         endif;
044945060703       enddo;
044946060703
044947060703      /end-free
044948060703     P                 E
044949060703
044950060703
044951060705      *++XferDataAscii++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044952060703      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
044953060705     P XferDataAscii   B
044954060705     D XferDataAscii   PI            10I 0
044955060703     D   aSession                          likeds(TSessionRec)
044956060703     D   iRecvProc                     *   value procptr
044957060703     D   iRecvDescr                  10I 0
044958060703     D   iSendProc                     *   value procptr
044959060703     D   iSendDescr                  10I 0
044960060703     D   iCD                               const likeds(TIconv)
044961060705
044962060705     D RecvData        PR            10I 0 extproc(iRecvProc)
044963060705     D   iDescr                      10I 0 value
044964060705     D   iBuffer                  32766A   options(*varsize)
044965060705     D   iBufLen                     10I 0 value
044966060705
044967060705     D SendData        PR            10I 0 extproc(iSendProc)
044968060705     D   iDescr                      10I 0 value
044969060705     D   iBuffer                  32766A   options(*varsize)
044970060705     D   iBufLen                     10I 0 value
044971060705
044972060705     D nRead           S             10I 0
044973060705     D nSent           S             10I 0
044974060705
044975060705     D InpBuffer       S          32766A
044976060705     D OutBuffer       S          32766A
044977060705     D InpPtr          S               *
044978060705     D OutPtr          S               *
044979060705     D InpLen          S             10U 0
044980060705     D OutLen          S             10U 0
044981060705     D rcu             S             10U 0
044982060705
044983060705      * because the read/write procedures in this SrvPgm are defined with
044984060705      * 32766A options(*varsize) instead of * (which is actually the same),
044985060705      * we have to do some ugly hacking to make things work :-(
044986060705     D pVirtInpBuffer  S               *
044987060705     D VirtInpBuffer   S          32766A   based(pVirtInpBuffer)
044988060705      *-------------------------------------------------------------------------
044989060703      /free
044990060705
044991060705       InpLen = 0;
044992060705       OutLen = %Size(OutBuffer);
044993060705       OutPtr = %Addr(OutBuffer);
044994060705
044995060705       dow (OutLen > 0);
044996060705         // read some data from the source
044997060705         InpPtr = %Addr(InpBuffer);
044998060705         // nRead = RecvData(iRecvDescr: InpPtr + InpLen: ...);
044999060705         pVirtInpBuffer = InpPtr + InpLen;
045000060705         nRead = RecvData(iRecvDescr: VirtInpBuffer: %size(InpBuffer) - InpLen);
045001060705
045002060705         select;
045003060705         when (nRead < 0);
045004060705           return CloseData(aSession);
045005060705
045010060705         when (nRead = 0) and (InpLen = 0);
045011060705           // file is done, conversion is done; let's flush what we have left
045012060705           exsr FlushOutBuffer;
045013060705           CloseData(aSession);
045014060705           leave;
045015060705         endsl;
045031060705
045032060705         // convert the data in the input buffer (left over + newly read)
045033060705         InpLen = InpLen + nRead;
045034060705         rcu = iconv(iCD: InpPtr: InpLen: OutPtr: OutLen);
045035060705
045036060705         // some less than usual condition occured
045037060705         if (rcu = cMaxUnsigned);
045038060705           select;
045039060705           when (ErrNo = EINVAL);
045040060705             // there is a partial character at the end of the input buffer
045041060705             if (nRead = 0);
045042060705               // too bad, we got an orphan; anyway, let's write what we have
045043060705               exsr FlushOutBuffer;
045044060705               // end then leave in shame
045045060705               return CloseData(aSession);
045046060705             else;
045049060705               // let's carry it over into the input buffer
045050060705               MemMove(%Addr(InpBuffer): InpPtr: InpLen);
045051060705             endif;
045052060705
045053060705           when (ErrNo = E2BIG);
045054060705             // output buffer is full while still some chars in input buffer
045055060705             // let's flush the output buffer
045056060705             exsr FlushOutBuffer;
045057060705             // let's carry the remaining chars over into the input buffer
045058060705             MemMove(%Addr(InpBuffer): InpPtr: InpLen);
045059060705
045060060705           other;
045061060705             // Houston, we've got a problem!
045062060705             SetError(aSession: FTP_ERRCONV: %str(StrError(ErrNo)));
045064060705             SndDiagMsg(aSession.ErrorStr: aSession.Handle);
045065060705             return CloseData(aSession);
045066060705           endsl;
045067060705         else;
045068060705
045069060705           if (OutLen = 0);
045070060705             // out buffer is full, flush it
045071060705             // this is the norm when converting from SBCS to SBCS
045072060705             exsr FlushOutBuffer;
045073060705           endif;
045074060705
045075060705         endif;  // if (rcu = cMaxUnsigned);
045076060705       enddo;
045084060705
045085060705       return 0;
045086060703
045087060705
045088060705       // ----------------------------------------------------------------------
045089060705       begsr FlushOutBuffer;
045090060705         nSent = SendData(iSendDescr: OutBuffer: %size(OutBuffer) - OutLen);
045091060705         if (nSent >= 0);
045092060705           OutPtr = %addr(OutBuffer);
045093060705           OutLen = %size(OutBuffer);
045094060705         else;
045095060705           SndDiagMsg(aSession.ErrorStr: aSession.Handle);
045098060705           return CloseData(aSession);
045099060705         endif;
045100060705       endsr;
045101060705
045102060703      /end-free
045103060703     P                 E
045104060703
045105060705
045106060705      *++XferDataBinary+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045107060705      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045108060705     P XferDataBinary  B
045109060705     D XferDataBinary  PI            10I 0
045110060705     D   aSession                          likeds(TSessionRec)
045111060705     D   iRecvProc                     *   value procptr
045112060705     D   iRecvDescr                  10I 0
045113060705     D   iSendProc                     *   value procptr
045114060705     D   iSendDescr                  10I 0
045115060705
045116060705     D RecvData        PR            10I 0 extproc(iRecvProc)
045117060705     D   iDescr                      10I 0 value
045118060705     D   iBuffer                  32766A   options(*varsize)
045119060705     D   iBufLen                     10I 0 value
045120060705
045121060705     D SendData        PR            10I 0 extproc(iSendProc)
045122060705     D   iDescr                      10I 0 value
045123060705     D   iBuffer                  32766A   options(*varsize)
045124060705     D   iBufLen                     10I 0 value
045125060705
045126060705     D nRead           S             10I 0
045127060705     D nSent           S             10I 0
045128060705     D Buffer          S          32766A
045129060705      *-------------------------------------------------------------------------
045130060705      /free
045131060705
045132060705       dow (1 = 1);
045133060705         // read some data from the source
045134060705         nRead = RecvData(iRecvDescr: Buffer: %size(Buffer));
045135060705
045136060705         select;
045137060705         when (nRead < 0);
045138060705           return CloseData(aSession);
045139060705
045140060705         when (nRead = 0);
045141060705           // we are done
045142060705           return 0;
045143060705         endsl;
045144060705
045145060705         // write the data
045146060705         nSent = SendData(iSendDescr: Buffer: nRead);
045147060705
045148060705         if (nSent < 0);
045149060705           return CloseData(aSession);
045150060705         endif;
045151060705       enddo;
045152060705
045153060705      /end-free
045154060705     P                 E
045155060705
045156060703
045157060703      *++RecvDataLine+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045158060703      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045159060703     P RecvDataLine    B
045160060703     D RecvDataLine    PI            10I 0
045161060703     D   iHandle                     10I 0 value
045162060704     D   oBuffer                  32766A   options(*varsize)
045163060704     D   iBufLen                     10I 0 value
045164060703
045165060703     D wSessPtr        S               *
045166060703     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
045167060703
045168060703     D wPos            S             10I 0
045169060703     D wRead           S             10I 0
045170060703     D wBuffPtr        S               *
045171060703     D wBuffLen        S             10I 0
045172060703     D ErrorStr        S                   like(TErrorStr)
045173060704     D wCRLF           S                   like(TSessionRec.DataCRLF)
045174060703      *-------------------------------------------------------------------------
045175060703      /free
045176060703
045177060703       wSessPtr = GetActSession(iHandle);
045178060703       // this should actually never happen; should be an assertion instead
045179060703       if (wSessPtr = *NULL);
045180060703         SetError(wSession: FTP_BADHDL: cErrBadHandle);
045181060703         return -1;
045182060703       endif;
045183060704       wCRLF = wSession.DataCRLF;
045184060703
045185060703       dou (wPos <> 0) or (wSession.DataBLen = %size(wSession.DataBuff));
045186060704         // let's find the CRLF at the end of a line, if we got any data at all
045187060704         if (wSession.DataBLen > 0);
045188060704           wPos = %scan(wCRLF: %subst(wSession.DataBuff: 1: wSession.DataBLen));
045189060703         endif;
045190060703
045191060704         // get more data from the data channel
045192060704         if (wPos = 0);
045193060703           wBuffPtr = %addr(wSession.DataBuff) + wSession.DataBLen;
045194060703           wBuffLen = %size(wSession.DataBuff) - wSession.DataBLen;
045195060703           wRead = TCP_Recv(wSession.DataSocket: wBuffPtr: wBuffLen:
045196060703             wSession.Timeout: ErrorStr);
045197060703
045198060704           select;
045199060704           when (wRead > 0);
045200060703             wSession.DataBLen = wSession.DataBLen + wRead;
045201060704           when (wRead = 0);
045202060704             // remote site closed the connection; we are almost done
045203060704             // edge case: last line may not have a CRLF; we fake one
045204060704             if (wSession.DataBLen > 0);
045205060704               wPos = wSession.DataBLen + 1;
045206060704               wSession.DataBLen = wSession.DataBLen + %len(wCRLF);
045207060704             else;
045208060704               leave;
045209060704             endif;
045210060704           other;
045211060703             return AnalyzeResult(wSession: wRead: ErrorStr:
045212060703               FTP_ERRRECV: cErrRecvData);
045213060704           endsl;
045214060703         endif;
045215060703       enddo;
045216060703
045217060704       // connection closed without remaining data; this is normal
045218060703       if (wPos = 0);
045219060704         return 0;
045220060703       endif;
045221060703
045222060704       // we are interested in the data up to, but not including, the CRLF
045223060704       wRead = wPos - 1;
045224060704
045225060704       if (wRead = 0);
045226060704         // empty line; set a magic to flag this !
045227060704         wSession.EmptyLine = True;
045228060704       else;
045229060704         oBuffer = %subst(wSession.DataBuff: 1: wRead);
045230060704       endif;
045231060704
045232060704       // remove the obtained line (including CRLF) from the receive buffer
045233060704       wSession.DataBuff = %subst(wSession.DataBuff: wPos + %len(wCRLF));
045234060704       wSession.DataBLen = wSession.DataBLen - wRead - %len(wCRLF);
045235060703
045236060703       return wRead;
045237060703
045238060703      /end-free
045239060703     P                 E
045240060703
045241060704
045242060704      *++RecvDataStrm+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045243060704      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045244060704     P RecvDataStrm    B
045245060704     D RecvDataStrm    PI            10I 0
045246060704     D   iHandle                     10I 0 value
045247060704     D   oBuffer                  32766A   options(*varsize)
045248060704     D   iBufLen                     10I 0 value
045249060704
045250060704     D wSessPtr        S               *
045251060704     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
045252060704
045253060704     D wRead           S             10I 0
045254060704     D ErrorStr        S                   like(TErrorStr)
045255060704      *-------------------------------------------------------------------------
045256060704      /free
045257060704
045258060704       wSessPtr = GetActSession(iHandle);
045259060704       // this should actually never happen; should be an assertion instead
045260060704       if (wSessPtr = *NULL);
045261060704         SetError(wSession: FTP_BADHDL: cErrBadHandle);
045262060704         return -1;
045263060704       endif;
045264060704
045265060704       // get a chunk of data
045266060704       wRead = TCP_Recv(wSession.DataSocket: %addr(oBuffer): iBufLen:
045267060704                 wSession.Timeout: ErrorStr);
045268060704
045269060704       if (wRead < 0);
045270060704         return AnalyzeResult(wSession: wRead: ErrorStr:
045271060704           FTP_ERRRECV: cErrRecvData);
045272060704       endif;
045273060704
045274060704       return wRead;
045275060704
045276060704      /end-free
045277060704     P                 E
045278060704
045279060704
045280060705      *++SendDataStrm+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045281060705      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045282060705     P SendDataStrm    B
045283060705     D SendDataStrm    PI            10I 0
045284060705     D   iHandle                     10I 0 value
045285060705     D   oBuffer                  32766A   options(*varsize)
045286060705     D   iBufLen                     10I 0 value
045287060705
045288060705     D wSessPtr        S               *
045289060705     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
045290060705
045291060705     D wErrorStr       S                   like(TErrorStr)
045292060705     D rc              S             10I 0
045293060705      *-------------------------------------------------------------------------
045294060705      /free
045295060705
045296060705       wSessPtr = GetActSession(iHandle);
045297060705       // this should actually never happen; should be an assertion instead
045298060705       if (wSessPtr = *NULL);
045299060705         SetError(wSession: FTP_BADHDL: cErrBadHandle);
045300060705         return -1;
045301060705       endif;
045302060705
045306060705       rc = TCP_Send(wSession.DataSocket: %addr(oBuffer): iBufLen:
045307060705         wSession.Timeout: wErrorStr);
045308060705       return AnalyzeResult(wSession: rc: wErrorStr: FTP_ERRSEND: cErrSendData);
045309060705
045310060705      /end-free
045311060705     P                 E
045312060705
045313060705
045314060705
045315060705      *++CloseData++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045316060704      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045317060704     P CloseData       B
045318060704     D CloseData       PI            10I 0
045319060704     D   aSession                          likeds(TSessionRec)
045320060704
045321060704     D pCloseFile      S               *   procptr
045322060704     D CloseFile       PR            10I 0 extproc(pCloseFile)
045323060704     D   iFileDescr                  10I 0 value
045324060704      *-------------------------------------------------------------------------
045325060704      /free
045326060704
045327060704       callp close(aSession.DataSocket);
045328060704       aSession.DataSocket = -1;
045329060704
045330060704       // if there was a file involved, close it, too
045331060704       if (aSession.ClosePtr <> *NULL) and (aSession.FileDescr >= 0);
045332060704         pCloseFile = aSession.ClosePtr;
045333060704         CloseFile(aSession.FileDescr);
045334060704       endif;
045335060704
045336060704       // in case one of those were set, we make sure to reset them
045337060704       aSession.ClosePtr = *NULL;
045338060704       aSession.FileDescr = -1;
045339060704
045340060704       // if called with result, it is a short cut to signal error condition
045341060704       return -1;
045342060704
045343060704      /end-free
045344060704     P                 E
045345060704
045346060704
045347060704      *++OpenFileRead+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045348060704      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045349060704     P OpenFileRead    B
045350060704     D OpenFileRead    PI            10I 0
045351060704     D   aSession                          likeds(TSessionRec)
045352060704     D   iLclPath                   256A   const
045353060704
045354060704     D wFileD          S             10I 0
045355060704     D wMode           S             10I 0
045356060704      *-------------------------------------------------------------------------
045357060704      /free
045358060704
045359060704       // for now we just assume it is an IFS file
045360060704       aSession.ClosePtr = %paddr(IF_Close);
045361060704       wFileD = Open(%trimr(iLclPath): O_RDONLY);
045362060704
045363060704       if (wFileD < 0);
045364060704         aSession.ClosePtr = *NULL;
045365060704         SetError(aSession: FTP_OPNERR: %str(StrError(ErrNo)));
045366060704         return -1;
045367060704       endif;
045368060704
045369060704       return wFileD;
045370060704
045371060704      /end-free
045372060704     P                 E
045373060704
045374060704
045375060704      *++OpenFileWrite++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045376060704      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045377060704     P OpenFileWrite   B
045378060704     D OpenFileWrite   PI            10I 0
045379060704     D   aSession                          likeds(TSessionRec)
045380060704     D   iLclPath                   256A   const
045381060704
045382060704     D wFileD          S             10I 0
045383060704     D wMode           S             10I 0
045384060704      *-------------------------------------------------------------------------
045385060704      /free
045386060704
045387060704       // for now we just assume it is an IFS file
045388060704       aSession.ClosePtr = %paddr(IF_Close);
045389060704       wMode = S_IRWXU + S_IRWXG + S_IRWXO;
045390060704       wFileD = Open(%trimr(iLclPath): O_WRONLY + O_CREAT + O_TRUNC: wMode);
045391060704       if (wFileD < 0);
045392060704         SetError(aSession: FTP_OPNERR: %str(StrError(ErrNo)));
045393060704         return -1;
045394060704       endif;
045395060704
045396060704       return wFileD;
045397060704
045398060704      /end-free
045399060704     P                 E
045400060704
045401060704
045402060704      *++IF_Read++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045403060704      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045404060704     P IF_Read         B
045405060704     D IF_Read         PI            10I 0
045406060704     D   iFileDes                    10I 0 value
045407060704     D   oBuffer                  32766A   options(*varsize)
045408060704     D   iBufLen                     10I 0 value
045409060704      *-------------------------------------------------------------------------
045410060704      /free
045411060704
045412060704       return Read(iFileDes: %addr(oBuffer): iBufLen);
045413060704
045414060704      /end-free
045415060704     P                 E
045416060704
045417060704
045418060704      *++IF_Write+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045419060704      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045420060704     P IF_Write        B
045421060704     D IF_Write        PI            10I 0
045422060704     D   iFileDes                    10I 0 value
045423060704     D   iBuffer                  32766A   options(*varsize)
045424060704     D   iBufLen                     10I 0 value
045425060704      *-------------------------------------------------------------------------
045426060704      /free
045427060704
045428060704       return Write(iFileDes: %addr(iBuffer): iBufLen);
045429060704
045430060704      /end-free
045431060704     P                 E
045432060704
045433060704
045434060704      *++IF_Close+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045435060704      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045436060704     P IF_Close        B
045437060704     D IF_Close        PI            10I 0
045438060704     D   iFileDes                    10I 0 value
045439060704      *-------------------------------------------------------------------------
045440060704      /free
045441060704
045442060704       return Close(iFileDes);
045443060704
045444060704      /end-free
045445060704     P                 E
045446060704
045447060704
045448060704      *++List2Array+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045449060704      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045450060704     P List2Array      B
045451060704     D List2Array      PI            10I 0
045452060704     D   peHandle                    10I 0 value
045453060704     D   peBuffer                 32766A   options(*varsize)
045454060704     D   peBufLen                    10I 0 value
045455060704
045456060704     D wSessPtr        S               *
045457060704     D wSession        DS                  likeds(TSessionRec) based(wSessPtr)
045458060704
045459060704     D pDirEntry       s               *
045460060704     D wDirEntry       s            256A   based(PDirEntry)
045461060704      *-------------------------------------------------------------------------
045462060704      /free
045463060704
045464060704       wSessPtr = GetActSession(peHandle);
045465060704       // this should actually never happen; should be an assertion instead
045466060704       if (wSessPtr = *NULL);
045467060704         SetError(wSession: FTP_BADHDL: cErrBadHandle);
045468060704         return -1;
045469060704       endif;
045470060704
045471060704       // array is full, but we fake a successful write
045472060704       if (wSession.DirRmtCnt >= wSession.DirMaxCnt);
045473060704         wSession.DirRmtCnt = wSession.DirRmtCnt + 1;
045474060704         return peBufLen;
045475060704       endif;
045476060704
045477060704       // add another directory entry to the array
045478060704       pDirEntry = wSession.DirArrPtr + wSession.DirRmtCnt * %size(wDirEntry);
045479060704       wDirEntry = %subst(peBuffer: 1: peBufLen);
045480060704       wSession.DirRmtCnt = wSession.DirRmtCnt + 1;
045481060704
045482060704       return peBufLen;
045483060704
045484060704      /end-free
045485060704     P                 E
045486060704
045487060704
045488060626      *++AnalyzeResult++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045489060626      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045490060626     P AnalyzeResult   B
045491060703     D AnalyzeResult   PI            10I 0
045492060626     D   aSession                          likeds(TSessionRec)
045493060626     D   iResult                     10I 0 value
045494060626     D   iErrorStr                         const like(TErrorStr)
045495060629     D   iDftError                   10I 0 value
045496060629     D   iDftErrorStr                      const like(TErrorStr)
045497060629
045498060629     D   wError        S             10I 0
045499060629     D   wErrorStr     S                   like(TErrorStr)
045500060629      *-------------------------------------------------------------------------
045501060626      /free
045502060626
045503060626       if (iResult >= 0);
045504060626         return 0;
045505060626       endif;
045506060626
045507060629       wErrorStr = iDftErrorStr;
045508060629       if (iErrorStr <> '');
045509060629         wErrorStr = wErrorStr + ' (' + iErrorStr + ')';
045510060629       endif;
045511060629
045512060629       select;
045513060629       when (iResult = -1);
045514060629         wError = iDftError;
045515060629       when (iResult = teTimeout);
045516060629         wError = FTP_TIMOUT;
045517060629       when (iResult = teHostName);
045518060629         wError = FTP_BADHOST;
045519060629       when (iResult = teCreateSocket);
045520060629         wError = FTP_ERRSKT;
045521060629       when (iResult = teDisconnect);
045522060629         wError = FTP_DISCON;
045523060629       endsl;
045524060629
045525060629       // this is all real bad, thus we log it in the job log, too
045526060629       SetError(aSession: wError: wErrorStr);
045527060629       SndMessage('*DIAG': '*': 2: wErrorStr: aSession.Handle);
045528060629
045529060629       return -1;
045530060626
045531060626      /end-free
045532060626     P                 E
045533060626
045534060627
045535060629      *++SetError+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045536060629      *  copy error number & error message into the session record
045537060629      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045538060629     P SetError        B
045539060629     D SetError        PI
045540060629     D   aSession                          likeds(TSessionRec)
045541060629     D   iError                      10I 0 value
045542060629     D   iErrorStr                         const like(TErrorStr)
045543060629      *-------------------------------------------------------------------------
045544060629      /free
045545060629
045546060629       aSession.Error = iError;
045547060629       aSession.ErrorStr = iErrorStr;
045548060629
045549060629      /end-free
045550060629     P                 E
045551060629
045552060629
045553060627      *++SndDiagMsg+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045554060627      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045555060627     P SndDiagMsg      B
045556060627     D SndDiagMsg      PI
045557060627     D   iMsgTxt                    256A   const
045558060627     D   iHandle                     10I 0 value
045559060627      *-------------------------------------------------------------------------
045560060627      /free
045561060627
045562060627       SndMessage('*DIAG': '*': 1: iMsgTxt: iHandle);
045563060627
045564060627      /end-free
045565060627     P                 E
045566060627
045567060627
045568060627      *++SndInfoMsg+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045569060627      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045570060627     P SndInfoMsg      B
045571060627     D SndInfoMsg      PI
045572060627     D   iMsgTxt                    256A   const
045573060627     D   iHandle                     10I 0 value
045574060627      *-------------------------------------------------------------------------
045575060627      /free
045576060627
045577060627       SndMessage('*INFO': '*': 0: iMsgTxt: iHandle);
045578060627
045579060627      /end-free
045580060627     P                 E
045581060627
045582060627
045583060627      *++SndMessage+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045584060627      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045585060627     P SndMessage      B
045586060627     D SndMessage      PI
045587060627     D   iMsgType                    10A   const
045588060627     D   iCallStkEnt                 10    const
045589060627     D   iCallStkCnt                 10I 0 const
045590060627     D   iMsgTxt                    256A   const
045591060627     D   iHandle                     10I 0 value
045592060627
045593060627     D wMsgText        S            256A
045594060627     D wMsgLen         S             10I 0
045595060627     D wMsgKey         S              4A
045596060627
045597060627     D wMsgError       DS                  qualified
045598060627     D   NbrBytesPrv                 10I 0 inz(0)
045599060627     D   NbrBytesAvl                 10I 0 inz(0)
045600060627      *-------------------------------------------------------------------------
045601060627      /free
045602060627
045603060627       wMsgText = %char(iHandle) + ': ' + iMsgTxt;
045604060627       wMsgLen = %len(%trimr(wMsgText));
045605060627
045606060627       QMHSNDPM('CPF9897': 'QCPFMSG   *LIBL': wMsgText: wMsgLen: iMsgType:
045607060627          iCallStkEnt: iCallStkCnt: wMsgKey: wMsgError);
045608060627
045609060627      /end-free
045610060627     P                 E
045611060627
045612060627
045613060629      *++CreateCD+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045614060627      *  create a new conversion descriptor; release the old one first
045615060627      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045616060629     P CreateCD        B
045617060629     D CreateCD        PI
045618060629     D   aCD                               likeds(TIconv)
045619060627     D   iSrcCCSID                   10I 0 value
045620060627     D   iDstCCSID                   10I 0 value
045621060627
045622060627     D srcQtQCode      DS                  LikeDS(TQtQCode)
045623060627     D dstQtQCode      DS                  LikeDS(TQtQCode)
045624060627      *-------------------------------------------------------------------------
045625060627      /free
045626060627
045627060629       FreeCD(aCD);
045628060627
045629060627       srcQtQCode = *Allx'00';
045630060627       srcQtQCode.CCSID = iSrcCCSID;
045631060627       dstQtQCode = *Allx'00';
045632060627       dstQtQCode.CCSID = iDstCCSID;
045633060627
045634060629       aCD = QtqIconvOpen(dstQtQCode: srcQtQCode);
045635060627
045636060627      /end-free
045637060627     P                 E
045638060627
045639060627
045640060629      *++FreeCD+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045641060627      *  free an allcoated conversion descriptor
045642060627      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045643060629     P FreeCD          B
045644060629     D FreeCD          PI
045645060629     D   aCD                               likeds(TIconv)
045646060627      *-------------------------------------------------------------------------
045647060627      /free
045648060627
045649060629       if (aCD.return_value = 0);
045650060629         iconv_close(aCD);
045651060629         aCD.return_value = -1;
045652060627       endif;
045653060627
045654060627      /end-free
045655060627     P                 E
045656060627
045657060627
045658060627      *++TCP_Connect++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045659060627      *  general interface for creating & connecting a TCP socket to a remote
045660060627      *  port, optionally with timeout (utilizing a non-blocking socket)
045661060627      *
045662060627      *     peHost  = host/domain name or dotted-decimal format of the host
045663060627      *               to connect to
045664060627      *     pePort  = port number to connect to
045665060627      *  peTimeout  = (optional) if given, sockets will be
045666060627      *                        put in non-blocking mode, and the
045667060627      *                        connection will time out after this
045668060627      *                        many seconds if no data is received
045669060627      *  peErrorStr = (optional) more specific error description than by the
045670060627      *               error code (= result)
045671060627      *
045672060627      *  returns:     socket descriptor upon success or error code upon failure
045673060627      *               (error codes are < 0)
045674060627      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045675060627     P TCP_Connect     B
045676060627     D TCP_Connect     PI            10I 0
045677060629     D   iHost                      256A   const
045678060629     D   iPort                        5U 0 value
045679060629     D   iTimeout                    10I 0 value
045680060629     D   oErrorStr                         like(TErrorStr) options(*nopass)
045681060629
045682060629     D wSocket         S             10I 0
045683060627     D wIP             S             10U 0
045684060627     D wSA             DS                  likeds(sockaddr_i)
045685060627     D wTV             DS                  likeds(timeval)
045686060627     D wON             S             10I 0 inz(1)
045687060627     D wFdset          S             28A
045688060627     D rc              S             10I 0
045689060627      *-------------------------------------------------------------------------
045690060627      /free
045691060627
045692060629       SetParmErrStr(%parms: 4: '': oErrorStr);
045693060629
045694060629       if (ResolveIP(iHost: wIP) < 0);
045695060627         return teHostName;
045696060627       endif;
045697060627
045698060627       // get a stream socket for IPv4 with default protocol (TCP)
045699060627       wSocket = socket(AF_INET: SOCK_STR: IPPRO_IP);
045700060627
045701060627       if (wSocket < 0);
045702060627         return teCreateSocket;
045703060627       endif;
045704060627
045705060627       // change the socket to non-blocking
045706060627       fcntl(wSocket: F_SETFL: fcntl(wSocket: F_GETFL: 0) + O_NONBLOCK);
045707060627       // not sure of the value of FIONBIO; 131074? (0x00020002)
045708060627       // ioctl(wSocket: FIONBIO: %addr(wON));
045709060627
045710060627       wSA.sin_family = AF_INET;
045711060629       wSA.sin_port = iPort;
045712060627       wSA.sin_addr = wIP;
045713060627       wSA.sin_zero = *allx'00';
045714060627
045715060627       // try to connect; in the case of blocking sockets, that's all to do
045716060627       if (connect(wSocket: %addr(wSA): %size(wSA)) >= 0);
045717060627         return wSocket;
045718060627       endif;
045719060627
045720060627       // analyze a few error cases
045721060627       select;
045722060627       when (errno() = EINPROGRESS);
045723060627         // apparently we used a non-blocking socket; let's wait and see
045724060627         return wSocket;
045725060627       other;
045726060629         SetParmErrStr(%parms: 4: %str(StrError(errno)): oErrorStr);
045727060629         return -1;
045728060627       endsl;
045729060627
045730060627      /if defined(FALSE)
045731060627       // give the non-blocking socket time to connect successfully
045732060629       wTV.tv_sec = iTimeout;
045733060627       wTV.tv_usec = 0;
045734060627
045735060627       // flag which socket to test
045736060627       FD_ZERO(wFdset);
045737060627       FD_SET(wSocket: wFdset);
045738060627
045739060627       // wait for the socket being ready for writing
045740060627       rc = select(wSocket + 1: *NULL: %addr(wFdset): *NULL: %addr(wTV));
045741060627
045742060627       select;
045743060627       when (rc = 1);  // we asked for only one socket, thus we must be ready
045744060627         return wSocket;
045745060627       when (rc = 0);  // timeout; we give up
045746060627         return teTimeout;
045747060627       other;          // really screwed up
045748060629         SetParmErrStr(%parms: 4: %str(StrError(errno)): oErrorStr);
045749060629         return -1;
045750060627       endsl;
045751060627      /endif
045752060627
045753060627      /end-free
045754060627     P                 E
045755060627
045756060627
045757060627      *++TCP_Send+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045758060627      *  send a buffer of data with timeout (wrapper around send() API)
045759060627      *
045760060627      *     iSocket = socket descriptor of an open connection
045761060629      *  iBufferPtr = pointer to data to send
045762060629      *  iBufferLen = size of data in buffer to send
045763060627      *   iTimeout  = with a non-blocking socket, we'll wait the specified
045764060627      *               timeout (in seconds) until we give up sending the data
045765060627      *  peErrorStr = (optional) more specific error description than by the
045766060627      *               error code (= result)
045767060627      *
045768060627      *  returns:     0 if success, or error code < 0 upon failure
045769060627      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045770060627     P TCP_Send        B
045771060627     D TCP_Send        PI            10I 0
045772060629     D   iSocket                     10I 0 value
045773060629     D   iBufferPtr                    *   value
045774060629     D   iBufferLen                  10I 0 value
045775060629     D   iTimeout                    10I 0 value
045776060629     D   oErrorStr                         like(TErrorStr) options(*nopass)
045777060629
045778060627     D wTV             DS                  likeds(timeval)
045779060627     D wSent           S             10I 0
045780060627     D wFdset          S             28A
045781060627     D rc              S             10I 0
045782060627      *-------------------------------------------------------------------------
045783060627      /free
045784060627
045785060627       SetParmErrStr(%parms: 5: '': oErrorStr);
045786060629
045787060629       dow (iBufferLen > 0);
045788060629         // check if socket is read for writing, with timeout
045789060628         wTV.tv_sec = iTimeout;
045790060628         wTV.tv_usec = 0;
045791060628
045792060628         // flag which socket to test
045793060628         FD_ZERO(wFdset);
045794060628         FD_SET(iSocket: wFdset);
045795060628
045796060628         // wait for the socket being ready for writing
045797060628         rc = select(iSocket + 1: *NULL: %addr(wFdset): *NULL: %addr(wTV));
045798060628
045799060628         select;
045800060629         when (rc = 1); // and (FD_ISSET(iSocket: wFdset));
045801060628           // note: timeout values might add up to > iTimeout!
045802060628         when (rc = 0);  // timeout; we give up
045803060628           return teTimeout;
045804060628         other;          // really screwed up
045805060628           SetParmErrStr(%parms: 5: %str(strerror(errno)): oErrorStr);
045806060629           return -1;
045807060628         endsl;
045808060628
045809060628         // send data (or at least a chunk of it)
045810060629         rc = send(iSocket: iBufferPtr + wSent: iBufferLen: 0);
045811060627         select;
045812060627         when (rc > 0);  // sent at least some part of the buffer's data
045813060627           wSent = wSent + rc;
045814060629           iBufferLen = iBufferLen - rc;
045815060627           iter;
045816060627         when (rc = 0);               // should never happen
045817060629           return -1;
045818060627         when (errno = EPIPE);        // connection got lost
045819060629           return teDisconnect;
045820060628         other;                       // most likely a programming error
045821060627           SetParmErrStr(%parms: 5: %str(strerror(errno)): oErrorStr);
045822060629           return -1;
045823060627         endsl;
045824060628       enddo;
045825060628
045826060627       return 0;
045827060627
045828060627      /end-free
045829060627     P                 E
045830060627
045831060627
045832060627      *++TCP_Recv+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045833060627      *  returns:     number of bytes received, or error code < 0 upon failure
045834060627      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045835060627     P TCP_Recv        B
045836060627     D TCP_Recv        PI            10I 0
045837060629     D   iSocket                     10I 0 value
045838060629     D   iBufferPtr                    *   value
045839060629     D   iBufferLen                  10I 0 value
045840060629     D   iTimeout                    10I 0 value
045841060629     D   oErrorStr                         like(TErrorStr) options(*nopass)
045842060629
045843060627     D wTV             DS                  likeds(timeval)
045844060627     D wRcvd           S             10I 0
045845060627     D wFdset          S             28A
045846060627     D rc              S             10I 0
045847060627      *-------------------------------------------------------------------------
045848060627      /free
045849060627
045850060629       // clear the error string
045851060627       SetParmErrStr(%parms: 5: '': oErrorStr);
045852060629
045853060627       // wait for data to receive
045854060627       wTV.tv_sec = iTimeout;
045855060627       wTV.tv_usec = 0;
045856060627
045857060627       // flag which socket to test
045858060627       FD_ZERO(wFdset);
045859060627       FD_SET(iSocket: wFdset);
045860060627
045861060627       rc = select(iSocket + 1: %addr(wFdset): *NULL: *NULL: %addr(wTV));
045862060627
045863060627       select;
045864060627       when (rc > 0); // and (FD_ISSET(iSocket: wFdset));
045865060629         // some data is ready
045866060627       when (rc = 0);  // timeout; we give up
045867060627         return teTimeout;
045868060627       other;          // really screwed up
045869060627         SetParmErrStr(%parms: 5: %str(strerror(errno)): oErrorStr);
045870060629         return -1;
045871060627       endsl;
045872060627
045873060629       rc = recv(iSocket: iBufferPtr: iBufferLen: 0);
045874060627
045875060627       select;
045876060704       when (rc >= 0);
045877060627         return rc;
045878060704       other;                       // most likely a programming error
045879060627         SetParmErrStr(%parms: 5: %str(strerror(errno)): oErrorStr);
045880060629         return -1;
045881060627       endsl;
045882060627
045883060627      /end-free
045884060627     P                 E
045885060627
045886060629
045887060629      *++SetParmErrStr++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045888060629      *  sets a an optional out paramater of type TErrorStr
045889060629      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045890060629     P SetParmErrStr   B
045891060629     D SetParmErrStr   PI
045892060629     D   iMaxParms                   10I 0 value
045893060629     D   iErrStrParm                 10I 0 value
045894060629     D   iErrorStr                         const like(TErrorStr)
045895060629     D   oErrorStr                         like(TErrorStr)
045896060629      *-------------------------------------------------------------------------
045897060629      /free
045898060629
045899060629       if (iMaxParms >= iErrStrParm);
045900060629         oErrorStr = iErrorStr;
045901060629       endif;
045902060629
045903060629      /end-free
045904060629     P                 E
045905060629
045906060627
045907060629      *++ResolveIP++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045908060626      *  resolve host name in string fromat to IP address in unsigned int format
045909060626      *
045910060626      *  converts a host name from either dotted decimal format or
045911060626      *  from a host/domain name and gets the proper IP address for it
045912060626      *
045913060626      *  DNS (Domain Name Service) format is like: "mycomputer.myhost.com"
045914060626      *  host name is like: "hostname"
045915060626      *  dotted-decimal is like: 192.168.5.124
045916060626      *
045917060629      *  iHost = host name in host, DNS or dotted-decimal format
045918060629      *    oIP = IP address (unsigned integer)
045919060626      *
045920060629      *  returns: 0 = success, -1 = failure
045921060626      *
045922060626      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045923060626     P ResolveIP       B
045924060626     D ResolveIP       PI            10I 0
045925060629     D   iHost                      256A   const
045926060629     D   oIP                         10U 0
045927060626      *-------------------------------------------------------------------------
045928060626      /free
045929060626
045930060626       // assume dotted decimal format
045931060629       oIP = inet_addr(%trim(iHost));
045932060626
045933060629       if (oIP = cMaxUnsigned);
045934060626         // try to resolve via DNS lookup
045935060629         p_hostent = GetHostByName(%trim(iHost));
045936060626         if (p_hostent = *NULL);
045937060626           return -1;
045938060626         endif;
045939060629         oIP = h_addr;
045940060626       endif;
045941060626
045942060626       return 0;
045943060626
045944060626      /end-free
045945060626     P                 E
045946060626
045947060628
045948060628      *++FD_SET+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045949060628      *  set a file/socket descriptor flag to ON...  for use with select()
045950060628      *
045951060628      *  iFD     = file descriptor, whose flag should be set ON
045952060628      *  aFD_Set = bit set of file descriptor flags
045953060628      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045954060628     P FD_SET          B
045955060628     D FD_SET          PI
045956060628     D   iFD                         10I 0 value
045957060628     D   aFD_Set                     28A
045958060628
045959060628     D PtrArrUInt      S               *
045960060628     D ArrUInt         S             10U 0 dim(7) based(PtrArrUInt)
045961060628     D Idx             S             10I 0
045962060628     D BitMask         S             10U 0
045963060628      *-------------------------------------------------------------------------
045964060628      /free
045965060628
045966060628       // prevent overflow/underflow
045967060628       if (iFD <0) or (iFD > 224);
045968060628         return;
045969060628       endif;
045970060628
045971060628       // poor RPG type cast
045972060628       PtrArrUInt = %addr(aFD_Set);
045973060628       // each UINT holds 32 bits (+1 cause RPG is one-based)
045974060628       Idx = %div(iFD : 32) + 1;
045975060628
045976060628      /if defined(*V5R2M0)
045977060628       // left shift a single bit socket number modulo 32
045978060628       BitMask = 2 ** %rem(iFD: 32);
045979060628       // set the bit via bitwise OR
045980060628       ArrUInt(Idx) = %bitor(ArrUInt(Idx): Bitmask);
045981060628
045982060628      /else
045983060628       // shift the UInt right by the bit number
045984060628       BitMask = ArrUInt(Idx) * 2 ** -%rem(iFD: 32);
045985060628       //  and test for even (= bit cleared)
045986060628       if (%rem(BitMask: 2) = 0);
045987060628         // left shift a single bit socket number modulo 32
045988060628         BitMask = 2 ** %rem(iFD: 32);
045989060628         // add the bit (that is why we had to check, if it is cleared)
045990060628         ArrUInt(Idx) = ArrUInt(Idx) + Bitmask;
045991060628       endif;
045992060628      /endif
045993060628
045994060628      /end-free
045995060628     P                 E
045996060628
045997060628
045998060628      *++FD_ZERO++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
045999060628      *  clear all file/socket descriptor flags...  for use with select()
046000060628      *
046001060628      *  aFD_Set = bit set of file descriptor flags
046002060628      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
046003060628     P FD_ZERO         B
046004060628     D FD_ZERO         PI
046005060628     D   aFD_Set                     28A
046006060628      *-------------------------------------------------------------------------
046007060628      /free
046008060628
046009060628       aFD_SET = *allx'00';
046010060628
046011060628      /end-free
046012060628     P                 E
046013060628
046014060628
046015060628      *++FD_CLR+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
046016060628      *  set a file/socket descriptor flag to OFF...  for use with select()
046017060628      *
046018060628      *  iFD     = file descriptor, whose flag should be set OFF
046019060628      *  aFD_Set = set of file descriptor flags
046020060628      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
046021060628     P FD_CLR          B
046022060628     D FD_CLR          PI
046023060628     D   iFD                         10I 0 value
046024060628     D   aFD_Set                     28A
046025060628
046026060628     D PtrArrUInt      S               *
046027060628     D ArrUInt         S             10U 0 dim(7) based(PtrArrUInt)
046028060628     D Idx             S             10I 0
046029060628     D BitMask         S             10U 0
046030060628      *-------------------------------------------------------------------------
046031060628      /free
046032060628
046033060628       // prevent overflow/underflow
046034060628       if (iFD <0) or (iFD > 224);
046035060628         return;
046036060628       endif;
046037060628
046038060628       // poor RPG type cast
046039060628       PtrArrUInt = %addr(aFD_Set);
046040060628       // each UINT holds 32 bits (+1 cause RPG is one-based)
046041060628       Idx = %div(iFD : 32) + 1;
046042060628
046043060628      /if defined(*V5R2M0)
046044060628       // left shift a single bit socket number modulo 32
046045060628       BitMask = 2 ** %rem(iFD: 32);
046046060628       // clear the bit via bitwise AND of the inverse bit mask
046047060628       ArrUInt(Idx) = %bitand(ArrUInt(Idx): %bitnot(Bitmask));
046048060628
046049060628      /else
046050060628       // shift the UInt right by the bit number
046051060628       BitMask = ArrUInt(Idx) * 2 ** -%rem(iFD: 32);
046052060628       //  and test for odd (= bit set)
046053060628       if (%rem(BitMask: 2) = 1);
046054060628         // left shift a single bit socket number modulo 32
046055060628         BitMask = 2 ** %rem(iFD: 32);
046056060628         // subtract the bit (that is why we had to check, if it is set)
046057060628         ArrUInt(Idx) = ArrUInt(Idx) - Bitmask;
046058060628       endif;
046059060628      /endif
046060060628
046061060628      /end-free
046062060628     P                 E
046063060628
046064060628
046065060628      *++FD_ISSET+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
046066060628      *  check if a file/socket descriptor flag is set...  for use with select()
046067060628      *
046068060628      *  iFD     = file descriptor, whose flag should be checked
046069060628      *  iFD_Set = set of file descriptor flags
046070060628      *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
046071060628     P FD_ISSET        B
046072060628     D FD_ISSET        PI              N
046073060628     D   iFD                         10I 0 value
046074060628     D   aFD_Set                     28A
046075060628
046076060628     D PtrArrUInt      S               *
046077060628     D ArrUInt         S             10U 0 dim(7) based(PtrArrUInt)
046078060628     D Idx             S             10I 0
046079060628     D BitMask         S             10U 0
046080060628      *-------------------------------------------------------------------------
046081060628      /free
046082060628
046083060628       // prevent overflow/underflow
046084060628       if (iFD <0) or (iFD > 224);
046085060628         return;
046086060628       endif;
046087060628
046088060628       // poor RPG type cast
046089060628       PtrArrUInt = %addr(aFD_Set);
046090060628       // each UINT holds 32 bits (+1 cause RPG is one-based)
046091060628       Idx = %div(iFD : 32) + 1;
046092060628
046093060628      /if defined(*V5R2M0)
046094060628       // left shift a single bit socket number modulo 32
046095060628       BitMask = 2 ** %rem(iFD: 32);
046096060628       // check bit via bitwise AND
046097060628       return (%bitand(ArrUInt(Idx): Bitmask) > 0);
046098060628
046099060628      /else
046100060628       // shift the UInt right by the bit number
046101060628       BitMask = ArrUInt(Idx) * 2 ** -%rem(iFD: 32);
046102060628       //  and test for odd
046103060628       return (%rem(BitMask: 2) = 1);
046104060628      /endif
046105060628
046106060628      /end-free
046107060628     P                 E
046108060628
116002060626
116004060626      ***ErrNo******************************************************************
116005060626      *  return error number for Unix/C APIs
116006060626      *-------------------------------------------------------------------------
116007060626      *  most, if not all UNIX style APIs, and also quite a few other C APIs
116008060626      *  return only failure; the exact error condition is to be found in the
116009060626      *  global variable errno
116010060626      *  we have to call the external procedure __errno, which gets us the
116011060626      *  POINTER to the actual errno (which is not really that global, but a
116012060626      *  thread safe variable)
116013060626      *  if you treat errno as a hex number and add the prefix 'CPE', you get
116014060626      *  a proper i5/OS message ID, in case you need one
116015060626      *
116016060626      *  reference: QSYSINC/H/ERRNO
116017060626      **************************************************************************
116018060626     P ErrNo           B
116019060626     D ErrNo           PI            10I 0
116020060626
116021060626     D GetPtrErrNo     PR              *   extproc('__errno')
116022060626
116023060626     D PErrNo          S               *
116024060626     D Result          S             10I 0 based(PErrNo)
116025060626      *-------------------------------------------------------------------------
116026060626      /free
116027060626
116028060626       PErrNo = GetPtrErrNo;
116029060626       return Result;
116030060626
116031060626      /end-free
116032060626     P                 E
116033060626
116034060704
116035060704      ***SetFileCCSID***********************************************************
116036060704      *  set the CCSID of a file in the IFS using Qp0lSetAttr
116037060704      *-------------------------------------------------------------------------
116038060704      *  http://publib.boulder.ibm.com/infocenter/iseries/v5r4/topic/apis/
116039060704      *         qsetattr.htm
116040060704      **************************************************************************
116041060704     P SetFileCCSID    B
116042060704     D SetFileCCSID    PI            10I 0
116043060704     D   iFilePath                         Value Like(TFilePath)
116044060704     D   iFileCCSID                  10I 0 Const
116045060704
116046060704     D QlgPathName     DS                  LikeDS(TQlgPathName)
116047060704
116048060704      /if defined(*V5R2M0)
116049060704     D AttrBuffer      DS                  Qualified
116050060704     D   Header                            LikeDS(TQp0lAttrHdr)
116051060704     D   CCSID                       10U 0
116052060704
116053060704      /else
116054060704     D AttrBuffer      DS                  Qualified
116055060704     D   Header                            Like(TQp0lAttrHdr)
116056060704     D   CCSID                       10U 0
116057060704
116058060704     D PtrHeader       S               *   Inz(%Addr(AttrBuffer.Header))
116059060704     D Header          DS                  LikeDS(TQp0lAttrHdr) Based(PtrHeader)
116060060704      /endif
116062060704      *-------------------------------------------------------------------------
116063060704      /free
116064060704
116065060704       InitQlgPathPtr(QlgPathName: %Addr(iFilePath) + 2: %Len(iFilePath));
116066060704
116067060704      /if defined(*V5R2M0)
116068060704       AttrBuffer.Header = *Allx'00';
116069060704       AttrBuffer.Header.AttrID = QP0L_ATTR_CCSID;
116070060704       AttrBuffer.Header.AttrSize = %Size(AttrBuffer.CCSID);
116071060704
116072060704      /else
116073060704       Header = *Allx'00';
116074060704       Header.AttrID = QP0L_ATTR_CCSID;
116075060704       Header.AttrSize = %Size(AttrBuffer.CCSID);
116076060704      /endif
116077060704
116078060704       AttrBuffer.CCSID = iFileCCSID;
116079060704
116080060704       Return Qp0lSetAttr
116081060704         (QlgPathName: AttrBuffer: %Size(AttrBuffer): QP0L_FOLLOW_SYMLNK);
116082060704
116083060704      /end-free
116084060704     P                 E
116085060704
116086060704
116087060704      ***InitQlgPathPtr*********************************************************
116088060704      *  initialize a TQlgPathName using a pointer to the path name
116089060704      *-------------------------------------------------------------------------
116090060704      *  this procedure assumes that we are using a single byte slash as path
116091060704      *  seperator and the job's CCSID, country & language settings
116092060704      *  note: using a pointer eliminates any restriction on the length of the
116093060704      *        path name
116094060704      **************************************************************************
116095060704     P InitQlgPathPtr  B
116096060704     D InitQlgPathPtr  PI
116097060704     D   aQlgPathName                      LikeDS(TQlgPathName)
116098060704     D   iPathPtr                      *   Value
116099060704     D   iPathSize                   10I 0 Value
116100060704      *-------------------------------------------------------------------------
116101060704      /free
116102060704
116103060704       aQlgPathName = *Allx'00';
116104060704       aQlgPathName.PathDelim = '/';
116105060704       aQlgPathName.PathType = QLG_PTR_SINGLE;
116106060704       aQlgPathName.PathPtr = iPathPtr;
116107060704       aQlgPathName.PathLen = iPathSize;
116108060704
116109060704      /end-free
116110060704     P InitQlgPathPtr  E
116111060704
